unit scamera;
interface
uses scTypes,space_u,K_sprite,math_unt,Sship,k_math;
type
  ECameraType = (CameraNull,CameraOne,CameraCenter,CameraForward,CameraTow);
                {mainAndItsTarget,HumenPlayers}
  OCameraControl = object
    {ships:array[0..maxNumShips]of POship;}
    destCamera:Rcamera;
    mainShipIndex:byte;
    minZoom,MaxZoom:real;
    numberOfShips:byte;
    cameraType:byte;
    lastEnemyInd:byte;
    shipLastX,shipLastY:real;
    procedure Cnew(inNumOfShips:byte);
    procedure update(ships:array of POship;var camera:Rcamera;world:Rworld;zoomCommand:byte);
    procedure mainShipCheck(ships:array of POship);
    procedure CameraNormal(ships:array of POship;var camera:Rcamera);
    procedure CameraForward(ships:array of POship;var camera:Rcamera);
    procedure CameraMeAndTarget(ships:array of POship;var camera:Rcamera);
    procedure CameraZoomMeAndTarget(ships:array of POship;var camera:Rcamera);
    procedure CameraZoomAllInView(ships:array of POship;var camera:Rcamera);

  end;

implementation

  procedure OCameraControl.Cnew(inNumOfShips:byte);
  begin
    numberOfships:=inNumOfShips;
  end;


  procedure OCameraControl.update(ships:array of POship;var camera:Rcamera;world:Rworld;zoomCommand:byte);
  var
    i,j,num,x,y:integer;
    maxDis,mapS,dx,dy:real;
  begin
     minZoom:=1; MaxZoom:=5;  {move to constractor}
     mainShipCheck(ships);
     if zoomCommand=1 then camera.zoom:=camera.zoom+0.05;
     if(zoomCommand=2)then
     begin
       camera.zoom:=camera.zoom-0.05;
     end;

     {cameraZoomAllInView(camera);}
     CameraZoomMeAndTarget(ships,camera);
     camera.zoom:=max(min(camera.zoom,min(2*world.sizeX/camera.screenX,2*world.sizeY/camera.screenY)),0.5);
     camera.zoom:=max(min(camera.zoom,maxZoom),minZoom); {remove line above; add set zoomMinMax,with limit}
{     if(mouse.lb=0)and(mouse.b=2)then
      begin
        cameraX:=(mouse.getX-160+camera.Y)*camera.zoom;
        cameraY:=(mouse.getY-100+camera.Y)*camera.zoom;
      end;
      if(mouse.b=2)then
      begin
        Camera.X:=cameraX/camera.zoom;
        Camera.Y:=cameraY/camera.zoom;
      end;}
{      CameraCircle(camera,cameraX,cameraY,5,100,ad);}



{      num:=0;
      for i:=0 to maxShips do
        if ships[i].getLife then
        begin
          Camera.x:=(num*Camera.x+ships[i].getX/camera.zoom)/(num+1);
          Camera.y:=(num*Camera.y+ships[i].getY/camera.zoom)/(num+1);
          inc(num);
        end;}

    {case cameraType}
{    CameraNormal(camera);}
     CameraMeAndTarget(ships,camera);
     if max(abs(ships[mainShipIndex]^.getX-shipLastX)/16,abs(ships[mainShipIndex]^.getY-shipLastY)/10)/camera.zoom>2 then
     begin
       camera.x:=destCamera.x;
       camera.y:=destCamera.y
     end;
     shipLastX:=ships[mainShipIndex]^.getX;
     shipLastY:=ships[mainShipIndex]^.getY;

     camera.Y:=min(Camera.Y,World.sizeY/camera.zoom-camera.ScreenY/2);
     camera.Y:=max(Camera.Y,-World.sizeY/camera.zoom+camera.ScreenY/2);
     camera.X:=min(Camera.X,World.sizeX/camera.zoom-camera.ScreenX/2);
     camera.X:=max(Camera.X,-World.sizeX/camera.zoom+camera.ScreenX/2);
  end;

  procedure OCameraControl.mainShipCheck(ships:array of POship);
  var
    i:integer;
  begin {change to get phisical}
    if not(ships[mainShipIndex]^.getDeathTime<400) then
    begin
      {change CameraMode if mode is normal or forward}
      i:=-1;
      repeat
        i:=i+1;
      until(i=numberOfShips)or(ships[i]^.getLife);
      mainShipIndex:=i;
    end;
  end;

  procedure OCameraControl.CameraNormal(ships:array of POship;var camera:Rcamera);
  begin
    camera.x:=ships[mainShipIndex]^.getX/camera.zoom;
    camera.y:=ships[mainShipIndex]^.getY/camera.zoom;
  end;

  procedure OCameraControl.CameraForward(ships:array of POship;var camera:Rcamera);
  begin {approved; to do:change 0 to ship index}
    destCamera.x:=(ships[mainShipIndex]^.getx+absMin(ships[mainShipIndex]^.getVx,1)*16*4)/camera.zoom;
    destCamera.y:=(ships[mainShipIndex]^.gety+absMin(ships[mainShipIndex]^.getVy,1)*10*4)/camera.zoom;

    camera.x:=(camera.x+0.1*destCamera.x)/1.1;
    camera.y:=(camera.y+0.1*destCamera.y)/1.1;
  end;

  procedure OCameraControl.CameraMeAndTarget(ships:array of POship;var camera:Rcamera);
  var
    enemyInd:byte;
   dx,dy:real;
  begin
    enemyInd:=ships[mainShipIndex]^.shipAI.enemyInd;
    destCamera.x:=(ships[mainShipIndex]^.getX+ships[enemyInd]^.getX)/2/camera.zoom;
    destCamera.y:=(ships[mainShipIndex]^.getY+ships[enemyInd]^.getY)/2/camera.zoom;

    camera.x:=(camera.x+0.05*destCamera.x)/1.05;
    camera.y:=(camera.y+0.05*destCamera.y)/1.05
  end;

  procedure OCameraControl.CameraZoomMeAndTarget(ships:array of POship;var camera:Rcamera);
  var
    enemyInd:byte;
  begin
    enemyInd:=ships[mainShipIndex]^.shipAI.enemyInd;
{    enemyInd:=mainShipIndex;}
    destCamera.zoom:=max(abs(ships[mainShipIndex]^.getX-ships[enemyInd]^.getX)/160,
            abs(ships[mainShipIndex]^.getY-ships[enemyInd]^.getY)/100)*1.1;
    if camera.zoom<destCamera.zoom then
      camera.zoom:=(camera.zoom+0.1*destCamera.zoom)/1.1
    else
      camera.zoom:=(camera.zoom+0.01*destCamera.zoom)/1.01;
{    camera.zoom:=1.5;}
  end;

  procedure OCameraControl.CameraZoomAllInView(ships:array of POship;var camera:Rcamera);
  var
    maxDis:real;
    i,j:integer;
  begin
    maxDis:=0.5;
    for i:=0 to numberOfShips do for j:=i+1 to numberOfShips do
      if(ships[i]^.getDeathTime<100)and(ships[j]^.getDeathTime<100)then
      begin
        maxDis:=max(maxDis,
        max(abs(ships[i]^.getX-ships[j]^.getX)/160,
            abs(ships[i]^.getY-ships[j]^.getY)/100));
      end;
    Camera.zoom:=maxDis;
  end;

  {add targetSelect}

begin
end.