{To Do: if enital life time is 0 then use shotProfile lifeTime init}
{add another input: possible change one for keys and one for spical}
unit SGun;
interface
uses crt,sctypes,sshotpro;
 Type

  EShotPosInit = (PInitNormal,PInitRandom,PInitHoming,PInitLaser);
  EShotDegInit = (DInitNormal,DInitRandom,DInitHoming,DInitLaser);
  Rgun = record  {to add shot profile}
    notActiveProb:real;
    {profile}
    PosInitType:EShotPosInit;
    DegInitType:EShotDegInit;

    NumShotsToFire:byte;
    ShotType1,ShotType2:byte;
    ShotTypeProb:real;
    LifeTimeMin,LifeTimeRange:Word;


    ShotDeg,ShotRange:real;
    PosDeg,PosRad,posRange:real;

    EnergyNeed:real;
    CoolDownTime:real;
    ActiveTime:integer;
    ControlKeys,ControlKeysAnd:Word;

    impSelf:RImpectData;

    deathActive:boolean;

  end;

  Ogun=object
    private
    data:Rgun;
    ShotPro:OshotsProfile; {********}
    active:word;
    CoolDown:real;
    ShotNum:byte;
    gunIndex:byte;
    public
    constructor Cnew(inGunIndex:byte);
    function isActive(inKeys:word;energy:real;life:boolean):boolean;
    procedure update;

    procedure GunHasShot;
    function getEnergyNeed:real;
    procedure getSelfForce(deg:real; var fx,fy:real);
    procedure getSelfImpect(var impSpec:RImpectData);
    function getInitX(x,deg:real):real;
    function getInitY(y,deg:real):real;
    function getInitDeg(deg:real):real;
    function getInitType:byte;
    function getInitLife:word;
    function allShotsFired:boolean;
    function shotReady(energy:real):boolean;

    procedure SetControl(ControlKeys,ControlKeysAnd:Word);
    function getShotProfile:POshotsProfile;

    procedure Load(fileName:string);
    procedure Save(fileName:string);

    procedure Init;
    procedure InitSmoke;
    procedure Init2;
    procedure InitLaser;
    procedure InitRound;
    procedure InitRandom;
    procedure InitExplotion;
    procedure InitGettingHit;
    procedure InitTurbo;
    procedure InitShild;
    procedure InitControlJam;
    procedure InitEng;
  end;

implementation
uses K_math,space_u;

  constructor Ogun.Cnew(inGunIndex:byte);
  begin
    gunIndex:=inGunIndex;

    data.notActiveProb:=0;
    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitNormal;

    data.NumShotsToFire:=0;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=0;
    data.ShotRange:=0;
    data.PosDeg:=0;
    data.PosRad:=0;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=0;
    data.ActiveTime:=0;
    data.ControlKeys:=0;
    data.ControlKeysAnd:=65535;
    data.impSelf.force:=0;
    data.impSelf.demege:=0;
    data.impSelf.energy:=0;
    data.impSelf.control:=0;
    data.deathActive:=false;

    active:=0;
    CoolDown:=0;
    ShotNum:=0;

  end;

  function Ogun.getShotProfile:POshotsProfile;
  begin
      getShotProfile:=@ShotPro;
  end;

  function Ogun.allShotsFired:boolean;
  begin
    allShotsFired:=ShotNum=data.NumShotsToFire;
  end;

  function Ogun.getInitType:byte;
  var
    initType:byte;
  begin
    if bern(data.ShotTypeProb) then
      initType:=data.ShotType2
    else
      initType:=data.ShotType1;

    if InitType=0 then
      getInitType:=maxShotPro+gunIndex
    else
      getInitType:=initType
  end;

  procedure Ogun.GunHasShot;
  begin
      CoolDown:=data.CoolDownTime; {can be done only once}
      inc(ShotNum);
  end;

  function Ogun.getEnergyNeed:real;
  begin
    getEnergyNeed:=ShotNum/data.NumShotsToFire*data.energyNeed;
  end;

  procedure Ogun.getSelfForce(deg:real; var fx,fy:real);
  begin
     fx:=fx+cos(deg)*data.impSelf.force;
     fy:=fy+sin(deg)*data.impSelf.force;
  end;

  procedure Ogun.getSelfImpect(var impSpec:RImpectData);
  begin
{     nromShotsfired:=ShotNum/data.NumShotsToFire;}
     impSpec:=data.impSelf; {normalize values according to shots fired}
  end;

  function Ogun.getInitX(x,deg:real):real;
  begin
    case data.PosInitType of
      PInitNormal:getInitX:=x+cos(deg+data.posDeg+(ShotNum-data.NumShotsTofire/2-0.5)
        /data.NumShotsTofire*data.posRange)*data.posRad;
      PInitLaser:getInitX:=x+cos(deg+data.posDeg)*(data.posRad+ShotNum/data.NumShotsTofire*data.shotRange);
      PInitRandom:getInitX:=x+random(500)-250;
    end;
  end;

  function Ogun.getInitY(y,deg:real):real;
  begin
    case data.PosInitType of
      PInitNormal:getInitY:=y+sin(deg+data.posDeg+(ShotNum-data.NumShotsTofire/2-0.5)
        /data.NumShotsTofire*data.posRange)*data.posRad;
      PInitLaser:getInitY:=y+sin(deg+data.posDeg)*(data.posRad+ShotNum/data.NumShotsTofire*data.shotRange);
      PInitRandom:getInitY:=y+random(500)-250;
    end;
  end;

  function Ogun.getInitDeg(deg:real):real;
  begin
    case data.DegInitType of
      DInitNormal:getInitDeg:=deg+data.shotDeg+(ShotNum-data.NumShotsTofire/2-0.5)/data.NumShotsTofire*data.ShotRange;
      DInitLaser:getInitDeg:=deg;
      DInitRandom:getInitDeg:=random(1000)/500*pi;
    end;
  end;

  function Ogun.getInitLife:word;
  begin
      getInitLife:=data.LifeTimeMin+round(random(1000)/1000*(data.LifeTimeRange));
  end;

  function Ogun.isActive(inKeys:word;energy:real;life:boolean):boolean;
  begin
      if( (data.controlKeys and inKeys>0)or(data.controlKeysAnd and inKeys = data.controlKeysAnd) )
      and(coolDown<=0)and(energy>=data.energyNeed)and(not(bern(data.notActiveProb)))
      and(life or data.deathActive) then
        active:=data.ActiveTime;
      isActive:=active > 0;
  end;

  procedure Ogun.update;
  begin
    if coolDown>0 then
      coolDown:=coolDown-1;
    if active>0 then
      active:=active-1;
    ShotNum:=0;
  end;

  function Ogun.shotReady(energy:real):boolean;
  begin
    ShotReady:=(energy>=data.EnergyNeed)and(coolDown=0);
  end;

  procedure Ogun.Load(fileName:string);
   var
    DataFile:File of Rgun;
  begin
     Assign(DataFile,fileName);
     Reset(DataFile);
     read(DataFile,data);
     Close(DataFile);
  end;

  procedure Ogun.Save(fileName:string);
  var
    DataFile:File of Rgun;
  begin
     Assign(DataFile,fileName);
     Rewrite(DataFile);
     write(DataFile,data);
     Close(DataFile);
  end;

  procedure Ogun.SetControl(ControlKeys,ControlKeysAnd:Word);
  begin
    data.ControlKeys:=ControlKeys;
    data.ControlKeysAnd:=ControlKeysand;
  end;

  procedure Ogun.Init;
  begin
    data.ControlKeys:=0;
    data.ControlKeysAnd:=65535;
    data.activeTime:=1;
    data.NumShotsToFire:=1;
  end;


  procedure Ogun.InitSmoke;
  begin
    data.LifeTimeMin:=22;
    data.LifeTimeRange:=5;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitRandom;
    data.NumShotsToFire:=2;
    data.ShotType1:=10; {smoke}
    data.ShotDeg:=pi;
    data.ShotRange:=0;
    data.EnergyNeed:=0;
    data.CoolDownTime:=4;
    data.ControlKeys:=AddBit(0,ord(CELowPower));
    data.ControlKeysAnd:=65535;
    data.activeTime:=1;
    data.PosDeg:=pi;
    data.PosRad:=7;
    data.deathActive:=false;

  end;

  procedure Ogun.Init2;
  begin

    data.LifeTimeMin:=70;
    data.LifeTimeRange:=5;

    data.NumShotsToFire:=1;
    data.ShotType1:=3;

    data.EnergyNeed:=30;
    data.CoolDownTime:=15;

    data.ControlKeys:=AddBit(0,ord(CShot1));

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitNormal;

    data.ShotDeg:=0;
    data.PosDeg:=0;

    data.PosRad:=pi;
    data.posRange:=pi;

    data.ShotRange:=1;
    data.deathActive:=false;
  end;

  procedure Ogun.InitLaser;
  begin
    data.LifeTimeMin:=1;
    data.LifeTimeRange:=0;

    {data.InitType:=SInitLaser;}
    shotPro.initProfile7;
    data.ShotType1:=0; {possivly}
{    data.ShotType2:=3;}

    data.activeTime:=1;
    data.ShotTypeProb:=0;

    data.PosInitType:=PInitLaser;
    data.DegInitType:=DInitLaser;
    data.NumShotsToFire:=50;
    data.ShotDeg:=-pi;
    data.EnergyNeed:=4;
    data.CoolDownTime:=0;
    data.ControlKeys:=AddBit(0,ord(CShot2));
{    data.ControlKeysAnd:=AddBit(0,ord(CStrifeL))+AddBit(0,ord(CStrifeR));}
    data.PosDeg:=0;
    data.PosRad:=4;
    data.posRange:=3*pi/2;
    data.ShotRange:=50;
    data.deathActive:=false;
  end;

  procedure Ogun.InitRound;
  begin
{    data.InitType:=SInitLaser;}
    data.LifeTimeMin:=50;
    data.LifeTimeRange:=0;

    data.NumShotsToFire:=50;
    data.ShotType1:=7;
    data.ShotDeg:=-pi;
    data.EnergyNeed:=150;
    data.CoolDownTime:=510;
    data.impSelf.control:=200;
    data.ControlKeys:=AddBit(0,ord(CDown));
{    data.ControlKeysAnd:=AddBit(0,ord(CStrifeL))+AddBit(0,ord(CStrifeR));}
    data.PosDeg:=0;
    data.PosRad:=4;
    data.posRange:=3*pi/2;
    data.ShotRange:=60;
    data.deathActive:=false;
  end;

  procedure Ogun.InitRandom;
  begin
{    data.InitType:=SInitRandom;}
    data.NumShotsToFire:=60;
    data.ShotType1:=2;
    data.ShotDeg:=-pi;
    data.EnergyNeed:=0;
    data.CoolDownTime:=2;
    data.ControlKeys:=AddBit(0,ord(CShot2));
    data.PosDeg:=0;
    data.PosRad:=4;
    data.posRange:=3*pi/2;
    data.ShotRange:=60;
  end;

  procedure Ogun.InitExplotion;
  begin
    ShotPro.initProExpPart;
   {profile}
    data.notActiveProb:=0.1;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitRandom;

    data.NumShotsToFire:=10;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;

    data.LifeTimeMin:=10;
    data.LifeTimeRange:=60;

    data.ShotDeg:=2*pi;
    data.ShotRange:=20; {check minnig}
    data.PosDeg:=0;
    data.PosRad:=0;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=0;
    data.ActiveTime:=70;
    data.ControlKeys:=AddBit(0,ord(CEdie));
    data.ControlKeysAnd:=65535{pow2(ord(CturnL))+pow2(ord(CturnR))};

    data.impSelf.force:=0;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;
    data.deathActive:=true;

  end;


   procedure Ogun.InitGettingHit; {chekif working}
   begin
    ShotPro.initProParticles;

    data.LifeTimeMin:=45;
    data.LifeTimeRange:=35;

   {profile}
    data.notActiveProb:=0.8;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitRandom;

    data.NumShotsToFire:=2;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=0;
    data.ShotRange:=0; {check minnig}
    data.PosDeg:=0;
    data.PosRad:=0;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=3;
    data.ActiveTime:=5;
    data.ControlKeys:=AddBit(0,ord(CEwasHit));
    data.ControlKeysAnd:=65535;

    data.impSelf.force:=0;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;

    data.deathActive:=true;
   end;

   procedure Ogun.InitTurbo;
   begin
    ShotPro.initProTurbo;

    data.LifeTimeMin:=20;
    data.LifeTimeRange:=0;

   {profile}
    data.notActiveProb:=0.2;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitNormal;

    data.NumShotsToFire:=1;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=pi;
    data.ShotRange:=0; {check minnig}
    data.PosDeg:=pi;
    data.PosRad:=8;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=170;
    data.ActiveTime:=30;
    data.ControlKeys:=0;{AddBit(0,ord(Cup));}
    data.ControlKeysAnd:=pow2(ord(Cup))+pow2(ord(CStrifeL))+pow2(ord(CStrifeR));{65535;}

    data.impSelf.force:=0.2;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;

    data.deathActive:=false;
   end;

   procedure Ogun.InitEng;
   begin
    ShotPro.initProTurbo;

    data.LifeTimeMin:=10;
    data.LifeTimeRange:=0;

   {profile}
    data.notActiveProb:=0.1;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitNormal;

    data.NumShotsToFire:=1;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=pi;
    data.ShotRange:=0; {check minnig}
    data.PosDeg:=pi;
    data.PosRad:=12;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=2;
    data.ActiveTime:=1;
    data.ControlKeys:=AddBit(0,ord(Cup));
    data.ControlKeysAnd:=65535;

    data.impSelf.force:=0;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;

    data.deathActive:=false;
   end;

   procedure Ogun.InitShild;
   begin
    ShotPro.initProShild;

   {profile}
    data.notActiveProb:=0;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitNormal;

    data.NumShotsToFire:=2;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=0;
    data.ShotRange:=0; {check minnig}
    data.PosDeg:=0;
    data.PosRad:=0;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=0;
    data.ActiveTime:=3;
    data.ControlKeys:=AddBit(0,ord(CEwasHit));
    data.ControlKeysAnd:=65535;

    data.impSelf.force:=0;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;

    data.LifeTimeMin:=2;
    data.LifeTimeRange:=8;

    data.deathActive:=false;
   end;

   procedure Ogun.InitControlJam;
   begin
    ShotPro.initControlJam;

   {profile}
    data.notActiveProb:=0.1;

    data.PosInitType:=PInitNormal;
    data.DegInitType:=DInitRandom;

    data.NumShotsToFire:=1;
    data.ShotType1:=0;
    data.ShotType2:=0;
    data.ShotTypeProb:=0;


    data.ShotDeg:=2*pi;
    data.ShotRange:=0; {check minnig}
    data.PosDeg:=0;
    data.PosRad:=0;
    data.posRange:=0;

    data.EnergyNeed:=0;
    data.CoolDownTime:=0;
    data.ActiveTime:=3;
    data.ControlKeys:=AddBit(0,ord(CEcontrolJam));
    data.ControlKeysAnd:=65535;

    data.impSelf.force:=0;
    data.impSelf.energy:=0;
    data.impSelf.demege:=0;
    data.impSelf.control:=0;

    data.LifeTimeMin:=30;
    data.LifeTimeRange:=10;

    data.deathActive:=false;
   end;

begin

end.