unit sshipAI;
interface
uses crt,math_unt,K_math,scTypes,mulTkey,mcga_vs,mcga_fnt,mcga_gui;
Const
  InputNum = 16;
  OutputNum = 8;
  MemoryNum = 4;

 type
  EinputType = (inNull,inEnemyDis,inEnemyDeg,inEnemyDegDis,inEnemyFdeg,inShotDis,inShotDeg,inShotDegDis,
  inAllieDis,inIsDown,inIsLeft,inIsOnEdge,inTime,inConst,inDisGrad);

  RshipAI = record
    EvalMat:array[1..OutputNum+MemoryNum,1..InputNum+memoryNum]of real;
    inputSpec:array[1..InputNum-1]of EinputType;
  end;

 OshipAI = object
    private
    input:word;
    Xdest,Ydest,degDest:real;
    EposX,EposY,Evx,Evy,
    EShotX,EshotY,EshotDis,
    allieX,allieY:real;

    inputs:array[1..InputNum+memoryNum]of real;
    Memory:array[1..MemoryNum]of real;




    enemyDis,lastEnemyDis,
    allieDis:real;
    { add EshotInd,EshotShipInd - to make point deffance}


    myX,myY:real;
    myFaction:byte;

    worldSizeX,worldSizeY:integer;

    public
    data:RshipAI;
    enemyInd:Byte;
    procedure Cnew;
    procedure update(inMyInd:byte;x,y:real);
    procedure selectTarget(ind,faction:byte;Ex,Ey,inEvX,inEvY:real;life:boolean);
    procedure selectEnemyShot(dis,EsX,EsY:real);

{    procedure SetEnemy(inEposX,inEposY,inEvX,inEvY:real);
    procedure SetEnemyShot(inEShotX,inEShotY:real);}

    procedure setFaction(faction:byte);
    function getFaction:byte;
    function getEnemyX:Real;
    function getEnemyY:Real;
    function getAllieX:Real;
    function getAllieY:Real;
    function getEshotX:Real;
    function getEshotY:Real;

    function InputNames(index:byte):string;
    function EvalControl(deg,x,y:real;controlType:byte;time,ad_fnt,ad:word):word;
    procedure MutatEvalMatrix(increments:real);
    procedure ClearEvalMatrix(MinVal:real);
    procedure GetEvalMatrix(var Mat:RshipAI);
    procedure SetEvalMatrix(var mat:RshipAI);
    procedure saveMat(name:string);
    procedure loadMat(name:string);
    procedure display(inp,outp:integer;minV:real;ad_fnt,ad:word);

 end;

   function getPosXIn(i:integer):integer;

   function getPosYIn(i:integer):integer;

   function getPosXout(i:integer):integer;

   function getPosYout(i:integer):integer;

implementation


  procedure OshipAI.Cnew;
  var
    i:integer;
  begin
    input:=0;
    Xdest:=0;
    Ydest:=0;
    degDest:=0;
    EposX:=0;EposY:=0;Evx:=0;Evy:=0;
    EShotX:=0;EshotY:=0;EshotDis:=0;
    allieX:=0;allieY:=0;

    for i:=1 to InputNum+memoryNum do
      inputs[i]:=0;
    for i:=1 to MemoryNum do
      Memory[i]:=0;

    enemyInd:=0;


    enemyDis:=0;
    lastEnemyDis:=0;
    allieDis:=0;
    { add EshotInd,EshotShipInd - to make point deffance}


    myX:=0;
    myY:=0;
    myFaction:=0;

    worldSizeX:=0;
    worldSizeY:=0;

  end;

  procedure OshipAI.setFaction(faction:byte);
  begin
    myFaction:=faction;
  end;

  function OshipAI.getFaction:byte;
  begin
    getFaction:=myFaction;
  end;

  procedure OshipAI.update(inMyInd:byte;x,y:real);
  var
    deg:word;

  begin
    enemyInd:=inMyInd;
    lastEnemyDis:=enemyDis;
    enemyDis:=10000;
    EshotDis:=10000;
    allieDis:=10000;
    eShotDis:=20000;

{    deg:=random(1024);
    EposX:=cos(deg/512*pi)*1000; {get EnemyInd}
 {   EposY:=sin(deg/512*pi)*1000;}
    myX:=x;
    myY:=y;
{    allieX:=x;
    allieY:=y;}
  end;



  function OshipAI.getEnemyX:Real;
  begin
    getEnemyX:=EposX;
  end;

  function OshipAI.getEnemyY:Real;
  begin
    getEnemyY:=EposY;
  end;

  function OshipAI.getAllieX:Real;
  begin
    getAllieX:=allieX;
  end;

  function OshipAI.getAllieY:Real;
  begin
    getAllieY:=allieY;
  end;

  function OshipAI.getEshotX:Real;
  begin
    getEshotX:=EshotX;
  end;

  function OshipAI.getEshotY:Real;
  begin
    getEshotY:=EshotY;
  end;

  procedure OshipAI.selectEnemyShot(dis,EsX,EsY:real);
  begin
    if(dis<EShotDis)then       {add only if shot is negetive}
    begin
      EShotDis:=dis;
      { to add shot ind and ship ind}
      EshotX:=EsX;
      EshotY:=EsY;
    end
  end;

                                                             {change to enemy power}
  procedure OshipAI.selectTarget(ind,faction:byte;Ex,Ey,inEvX,inEvY:real;life:boolean);
  var
    dis:real;
  begin

    dis:=max(abs(myX-Ex),abs(myY-Ey));
    if(myFaction<>faction)then
    begin
      if(life)and(dis<EnemyDis)then
      begin
        EnemyDis:=dis;
        EnemyInd:=ind;
        EposX:=Ex;
        EposY:=Ey;
        Evx:=inEvX;
        Evy:=inEvY;
      end
    end
    else
    begin
      if(life)and(dis<allieDis)then
      begin
        allieDis:=dis;
        allieX:=Ex;
        allieY:=Ey;
      end
    end
  end;


  function OshipAI.InputNames(index:byte):string;
  begin
    if index<inputNum then
    case data.inputSpec[index] of
      inEnemyDis:inputNames:='Dis';
      inEnemyDeg:inputNames:='Deg';
      inEnemyDegDis:inputNames:='DegDis';
      inShotDis:inputNames:='shotDis';
      inShotDeg:inputNames:='shotDeg';
      inShotDegDis:inputNames:='shotDegDis';
      inEnemyFdeg:inputNames:='EnemyFDeg';
      inDisGrad:inputNames:='DisGrad';

      inIsOnEdge:inputNames:='IsOnEdge';
      inTime:inputNames:='SinTime';
      inConst:inputNames:='Const';
      else inputNames:='Null';
    end
    else
      inputNames:='const';

  end;
  function OshipAI.EvalControl(deg,x,y:real;controlType:byte;time,ad_fnt,ad:word):word;
  var
    Edeg,Efdeg,eSDeg:real;
    i,j:integer;
    Val:real;
  begin
     worldSizeX:=320;
     WorldSizeY:=200;

     if controlType = 0 then
     begin
       {inputs initulaztion}
       Edeg:=getDeg(Eposx-myX,Eposy-myY);
       Efdeg:=getDeg((Eposx+eVx*enemyDis/3)-myX,(Eposy+eVy*enemyDis/3)-myY);
       eSdeg:=getDeg(eShotX-myX,eShotY-myY);
       for i:=1 to inputNum-1 do
       begin
         case data.inputSpec[i] of {move to function}
           inEnemyDis:inputs[i]:=min(EnemyDis/300,1){-1};
           inEnemyDeg:inputs[i]:=deg_sign(Edeg-deg)*deg_dis(eDeg,deg);
           inEnemyDegDis:inputs[i]:=deg_dis(eDeg,deg)-pi;
           inEnemyFDeg:inputs[i]:=deg_sign(eFDeg-deg)*deg_dis(eFDeg,deg);

           inShotDis:inputs[i]:=min(EShotDis/200,2)-1;
           inShotDeg:inputs[i]:=deg_sign(eSdeg-deg)*deg_dis(eSdeg,deg);
           inShotDegDis:inputs[i]:=deg_dis(eSdeg,deg)-pi;

           inIsOnEdge:inputs[i]:=max(abs(myX)/worldSizeX,abs(myY)/worldSizeY);

           inDisGrad:inputs[i]:=sign(enemyDis-LastEnemyDis)/2+1;
           inTime:inputs[i]:=Sin(time/(45+random(10))); {***}
           inConst:inputs[i]:=1;
           else inputs[i]:=0;
         end;
       end;
       inputs[inputNum]:=1; {Bais}

       {output evuluation}
       for i:=1 to OutputNum{+MemoryNum} do
       begin
          val:=0;
          for j:=1 to InputNum{+MemoryNum} do
            val:=val+data.EvalMat[i,j]*inputs[j];
          val:=f_cont(val/10); {activation function}

          input:=setBit(input,i-1,f_to_l(val));
       end;
     end;

{     if controlType = 0 then
     begin
        dis:=sqrt(sqr(Eposx-X)+sqr(Eposy-Y));
        eDeg:=getDeg(Eposx-(X-eVx*dis/3.5),Eposy-(Y-Evy*dis/3.5));

        EvalVars[1]:=f_cont(dis/100);
        EvalVars[2]:=1-f_cont(dis/100);
        EvalVars[3]:=deg_sign(Edeg-deg)*deg_dis(eDeg,deg);
        EvalVars[4]:=-deg_sign(Edeg-deg)*deg_dis(eDeg,deg);
        EvalVars[5]:=deg_dis(eDeg,deg)/pi;
        EvalVars[6]:=1-deg_dis(eDeg,deg)/pi;
        EvalVars[7]:=f_cont(eShotDis/100);
        EvalVars[8]:=1-f_cont(EShotdis/100);
        EvalVars[9]:=1;
        input:=0;
        for i:=1 to 6 do
        begin
          val:=0;
          for j:=1 to 9 do
            val:=val+data.EvalMatrix[i,j]*EvalVars[j];
          val:=f_cont(ArcTan(val/10));
          case i of
            1:input:=setBit(input,ord(CUP),f_to_l(val));
            2:input:=setBit(input,ord(CturnL),f_to_l(val));
            3:input:=setBit(input,ord(CturnR),f_to_l(val));
            4:input:=setBit(input,ord(CShot1),f_to_l(val));
            5:input:=setBit(input,ord(CStrifeL),f_to_l(val));
            6:input:=setBit(input,ord(CStrifeR),f_to_l(val));
          end;
        end;
       EshotDis:=1000;
     end;}

    if ControlType=1 then
    begin
      input:=setBit(input,ord(CUP),(key[72])or(key[17]));
      input:=setBit(input,ord(CDown),key[31]);
      input:=setBit(input,ord(CTurnL),(key[75])or(key[30]));
      input:=setBit(input,ord(CTurnR),(key[77])or(key[32]));
      input:=setBit(input,ord(CStrifeL),key[16]);
      input:=setBit(input,ord(CStrifeR),key[18]);
      input:=setBit(input,ord(Cshot1),(key[57])or(key[15]));
      input:=setBit(input,ord(Cshot2),key[41]);
    end;


     if controlType=2 then
     begin
      input:=0;
      Edeg:=getDeg(Eposx-(X-eVx*EnemyDis/3.5),Eposy-(Y-Evy*EnemyDis/3.5));
      if (enemyDis>100)or(random(100)=0) then
        input:=addBit(input,ord(CUP));

      input:=setBit(input,ord(CShot1),deg_dis(Edeg,deg)<0.2);
      if enemyDis>190 then
         input:=setBit(input,ord(CShot1),false);


{      if(EshotDis>=50)then}
        case deg_sign(edeg-deg) of
          -1:input:=addBit(input,ord(CturnL));
          1:input:=addBit(input,ord(CTurnR));
        end;
      if(f_to_l(min(max((60-EshotDis)/60,0),1)))then
        case deg_sign(getDeg(EShotX-X,EShotY-Y)-deg) of
          1:input:=addBit(input,ord(CstrifeL));
          -1:input:=addBit(input,ord(CstrifeR));
          0:begin
            if random(2)=0 then
              input:=addBit(input,ord(CstrifeL))
            else
              input:=addBit(input,ord(CstrifeR));
          end;
        end;
{        input:=setBit(input,ord(Cup),f_to_l(max(min(enemyDis/1400,1),0)));}
    end;

{     if controlType=3 then
     begin
      input:=0;
      mx:= getmousex div 2;
      my:= getmousey;
      dis:=sqrt(sqr(mx-X)+sqr(my-Y));
      case deg_sign(getDeg(mx-X,my-Y)-deg) of
        -1:input:=addBit(input,ord(CturnL));
        1:input:=addBit(input,ord(CTurnR));
      end;
      input:=setBit(input,ord(CShot1),leftpressed);
      input:=setBit(input,ord(CUp),Rightpressed);
{      input:=setBit(input,ord(CUP),(key[72])or(key[17]));
      input:=setBit(input,ord(CStrifeL),(key[75])or(key[30]));
      input:=setBit(input,ord(CStrifeR),(key[77])or(key[32]));}

 {   end;}

{    if controlType=3 then
    begin
      mx:= getmousex div 2;
      my:= getmousey;
      dis:=sqrt(sqr(mx-X)+sqr(my-Y));
      ControlLeft:=false;
      ControlRight:=false;
      case deg_sign(getDeg(mx-X,my-Y)-deg) of
          -1:ControlLeft:=true;
          1:ControlRight:=true;
      end;
      ControlUp:=(rightpressed)and(dis>60);
      ControlShot:=leftpressed ;
    end;}
    EvalControl:=input;
  end;



  procedure OshipAI.MutatEvalMatrix(increments:real); {obselet}
  var
    i,j,r:integer;
    rand,how:real;
  begin
    for i:=1 to 8 do
      for j:=1 to 12 do
      begin
        r:=random(2);
        how:=random(100)/100;
        case r of
          0:rand:=-increments*how;
          1:rand:=increments*how;
        end;
        data.EvalMat[i,j]:=data.EvalMat[i,j]+rand;
      end;
  end;

  procedure OshipAI.ClearEvalMatrix(MinVal:real);
  var
    i,j,r:integer;
    rand,how:real;
  begin
    for i:=1 to InputNum do
      for j:=1 to OutputNum do
{        if abs(data.EvalMat[i,j])<=minVal then }data.EvalMat[j,i]:=0;
  end;

  procedure OshipAI.GetEvalMatrix(var Mat:RshipAI);
  var
    i,j:integer;
  begin
     mat:=data;
  end;

  procedure OshipAI.SetEvalMatrix(var mat:RshipAI);
  var
    i,j:integer;
  begin
    data:=mat;
  end;

  procedure OshipAI.saveMat(name:string);
  var
    MatrixFile:File of RShipAI;
    i,j:integer;
  begin
     Assign(MatrixFile,name);
     Rewrite(MatrixFile);
     write(MatrixFile,data);
     Close(MatrixFile);
   end;

   procedure OshipAI.loadMat(name:string);
   var
    MatrixFile:File of RshipAI;
   begin
{     Assign(MatrixFile,name);
     Rewrite(MatrixFile);
     write(MatrixFile,data);
     Close(MatrixFile);}
     Assign(MatrixFile,name);
     Reset(MatrixFile);
     read(MatrixFile,data);
     Close(MatrixFile);
   end;

   function getPosXIn(i:integer):integer;
   begin
     getPosXIn:=160 - round(cos((i-4.5)/4.5)*90);
   end;

   function getPosYIn(i:integer):integer;
   begin
     getPosYIn:=100 + round(sin((i-4.5)/4.5)*90);
   end;

   function getPosXout(i:integer):integer;
   begin
     getPosXout:=200;
   end;

   function getPosYout(i:integer):integer;
   begin
     getPosYout:=10+i*20;
   end;

   procedure OshipAI.display(inp,outp:integer;minV:real;ad_fnt,ad:word);
   const
   OutputNames : array [1..8] of String =
     ('Up','Down','Turn R','Turn L','Strife R','Strife L','Shot1','Shot2');
   var
     inputsInd,outputsInd,inputNumber:integer;
     con:real;
     col:byte;

   begin
     cls(0,ad);
     setFontMode(32);
     setFontBcolor(16*3+4);
     inputNumber:=9;
           for outputsInd:=1 to 8 do
      for inputsInd:=1 to inputNumber do
      begin
        con:=data.EvalMat[outputsInd,inputsInd];
{        col:=round(sign(con)*16+16*3+min(abs(con)-minV,15));}
        col:=round(16*10-sign(con)*8+8);
        if abs(con)>minV then
          line(getPosXin(inputsInd),getPosYin(inputsInd),getPosXout(outputsInd),getPosYout(outputsInd),col,ad);
      end;
     for inputsInd:=1 to inputNumber do
     begin
       col:={16*5+8}72;
       if inputsInd=inp then col:=10;
       circle(getPosXin(inputsInd),getPosYin(inputsInd),5,col,ad);

       ShapeWindow(getPosXIn(inputsInd)-9,getPosYIn(inputsInd)-9
       ,getPosXIn(inputsInd)+9,getPosYIn(inputsInd)+9,5,5,1,col,ad);

       midtext(inputNames(inputsInd),0,getPosXin(inputsInd),getPosYin(inputsInd)-2,1,60,ad_fnt,ad);
     end;

     for outputsInd:=1 to 8 do
     begin
       col:=72;
       if outputsInd=outp then col:=10;
{       circle(getPosXout(outputsInd),getPosYout(outputsInd),5,col,ad);}
       ShapeWindow(getPosXout(outputsInd)-8,getPosYout(outputsInd)-8
       ,getPosXout(outputsInd)+8,getPosYout(outputsInd)+8,3,7,1,col,ad);
       puttext(outputNames[outputsInd],getPosXout(outputsInd)+20,getPosYout(outputsInd),1,60,ad_fnt,ad);
     end;

   end;
begin
end.