{add: undying shots,demegeTypes}
Unit sShotPro;
interface
uses scTypes,K_sprite;
type
  EmoveType = (MoveNormal,MoveHoming,MoveFuzzy,MoveRandom,MoveCos,MoveSelfHoming
  ,MoveAllieHoming,MoveAllieMiss,MoveHomingMiss,MoveAllieHomePlus);
  EdispType = (DispNull,DispPixel,DispDotCircle,DispCircle,DispDotCirPara,DispImpectExp,DispBall,
  DispCircleOn);
  EcolorType = (ColorFade,ColorInOut,ColorRandom); {random uses index and rand num}
  EsizeType = (SizeConst,SizeTime,SizeGrow,SizeGrowInOut,SizeCos);
  EdemegeType = (DemegeNormal,DemegeFade,DemegeGrow);
  EPhyType = (TPhysical,TPhysicalPresist,Teffect);{prob....}



  RshotProfile = record
      {Display}
      DispType:EdispType; {Display Type - selects: pixel, circle, ball...}
      DispPara:Word; {Depending on Display Type, influens the display}

      ColorMode:EcolorType; {Color Mode - selects: fadeIn, Fade In and out}
      ColorB,colorE:byte;

      {Size}
      SizeType:EsizeType; {const,Grow,Change); {*}
      Size:byte;
      SizeParam:real;

      {Behevior}
      LifeTimeMin,LifeTimeRange:word;

      degInit{,degInitGun}:byte; {*****************}
      {impact}
      TransOn:array[0..1,0..1]of byte;
      TransProb:array[0..1]of real;

      Physical:EPhyType;

      MoveSpeed:real;
      MoveType:EmoveType;
      MovePara:real;

      impEnemy:RImpectData;
  end;

  OshotsProfile = object
      private
      data:RshotProfile;
      public
      function getColor(shotInd,sTime,LifeTime:word):byte;
      function getSize(sTime,LifeTime:word):real;
      function getDemege(sTime,LifeTime:word):real;
      function getEnergy(sTime,LifeTime:word):real;
      function getControl(sTime,LifeTime:word):real;
      function getMoveType(sTime,LifeTime:word):EmoveType;
      function getLifeTimeInit:word;
      procedure Draw(x,y,deg:real;shotInd,sTime,LifeTime:word;camera:Rcamera;ad:word);
      function TransShot(select:byte):byte;
      function getPhysical:boolean;
      function getPresist:boolean;
      function getSpeed:real;
      procedure UpdateShot(ex,ey,allieX,allieY,myX,myY:real;sTime:word;var x,y,deg:real);
      function GetForceOnEnemy:real;

      procedure Load(fileName:string);
      procedure Save(fileName:string);

      function getDegInit:real;
{      function getDegInitGun:real;}


      procedure initProfile1;
      procedure initProfile2;
      procedure initProfile3Normal;
      procedure initProfile4;
      procedure initProfile5;
      procedure initProfile6;
      procedure initProfile7;
      procedure initProfile8;
      procedure initProfile10;
      procedure initProfile11ExpBall;
      procedure initProParticles;
      procedure initProTurbo;
      procedure initProShild;
      procedure initControlJam;
      procedure initProExpPart;

  end;
  POshotsProfile = ^OshotsProfile;
implementation
  uses crt,mcga_vs,space_u,K_math,math_unt;


  function OshotsProfile.getForceOnEnemy:real;
  begin
    getForceOnEnemy:=data.impEnemy.force;
  end;

  procedure OshotsProfile.Load(fileName:string);
   var
    ShotFile:File of RShotProfile;
  begin
     Assign(ShotFile,fileName);
     Reset(ShotFile);
     read(ShotFile,data);
     Close(ShotFile);
  end;

  procedure OshotsProfile.Save(fileName:string);
  var
    ShotFile:File of RShotProfile;
  begin
     Assign(ShotFile,fileName);
     Rewrite(ShotFile);
     write(ShotFile,data);
     Close(ShotFile);
  end;

  procedure OshotsProfile.UpdateShot(ex,ey,allieX,allieY,myX,myY:real;sTime:word;var x,y,deg:real);
  var
    dis,TotalDis,targetDeg:real;
  begin
      case data.moveType of
        MoveHoming:begin
          deg:=deg+data.MovePara*deg_sign(getDeg(Ex-x,EY-y)-deg);
        end;

        MoveSelfHoming:begin
            deg:=deg+data.MovePara*deg_sign(getDeg(myX-x,myY-y)-deg);
        end;

        MoveAllieHoming:begin
            deg:=deg+data.MovePara*deg_sign(getDeg(allieX-x,AllieY-y)-deg);
        end;

        MoveAllieMiss:begin
          if sqr(allieX-x)+sqr(AllieY-y)<900 then
           deg:=deg-data.MovePara*deg_sign(getDeg(allieX-x,AllieY-y)-deg);
        end;

        MoveHomingMiss:begin
           dis:=max(abs(allieX-x),abs(AllieY-y));
           totalDis:=max(abs(allieX-x),abs(AllieY-y))+max(abs(Ex-x),abs(Ey-y));
           targetDeg:=getDeg(allieX-x,AllieY-y);
           deg:=deg-data.MovePara*(
           (TotalDis-dis)*deg_sign(targetDeg-deg)/deg_abs(targetDeg-deg)/7
           -dis*deg_sign(getDeg(Ex-x,Ey-y)-deg))/totalDis;
        end;

{        MoveAllieHomePlus:begin
           dis:=max(abs(Ex-x),abs(Ey-y));
           totalDis:=max(abs(allieX-x),abs(AllieY-y))+max(abs(Ex-x),abs(Ey-y));
           targetDeg:=getDeg(Ex-x,Ey-y);
           deg:=deg-data.MovePara*(
           (TotalDis-dis)*deg_sign(targetDeg-deg)/deg_abs(targetDeg-deg)/7
           -dis*deg_sign(getDeg(AllieX-x,AllieY-y)-deg))/totalDis;
        end;}

        MoveFuzzy:begin {to change}
            if(f_to_l(deg_abs(getDeg(Ex-x,EY-y)-deg)/pi))then
            if(deg_sign(getDeg(Ex-x,EY-y)-deg)=1)then
               deg:=deg+pi*data.MovePara
            else
              deg:=deg-pi*data.MovePara;
        end;

        MoveCos:begin
          deg:=deg+cos(sTime/10)*data.movePara;
        end;

      end;
      x:=x+getSpeed*cos(deg); {?to change to var speed}
      y:=y+getSpeed*sin(deg);
  end;

  function OshotsProfile.getDegInit:real;
  begin {what the Fu** did I do?}
    getDegInit:=(Random(data.degInit*4+1)-data.degInit*2)/(data.degInit+1)*pi;
  end;

{  function OshotsProfile.getDegInitGun:real;
{  begin {to replace with math function}
 {   getDegInitGun:=(Random(data.degInitGun*4+1)-data.degInitGun*2)/(data.degInitGun+1)*pi;
  end;}

  function OshotsProfile.getSpeed:real;
  begin
    getSpeed:=data.MoveSpeed;
  end;

  function OshotsProfile.getPhysical:boolean;
  begin
    getPhysical:=(data.Physical = TPhysical) or (data.Physical = TPhysicalPresist);
  end;

  function OshotsProfile.getPresist:boolean;
  begin
    getPresist:=(data.Physical = TPhysicalPresist);
  end;

  function OShotsProfile.getMoveType(sTime,LifeTime:word):EmoveType;
  begin
    getMoveType:=data.MoveType; {temp********}
  end;

  function OShotsProfile.getLifeTimeInit:word;
  begin
    getLifeTimeInit:=data.LifeTimeMin+round(random(1000)/1000*(data.LifeTimeRange));
  end;

  function OShotsProfile.TransShot(select:byte):byte;
  begin
    if bern(data.TransProb[select])then
      TransShot:=data.TransOn[select,0]
    else
      TransShot:=data.TransOn[select,1];
  end;

  function OshotsProfile.getColor(shotInd,sTime,LifeTime:word):byte;
  begin
    case data.colorMode of
      colorFade:getColor:=round(data.colorB+(sTime/LifeTime)*(data.colorE-data.colorB));
      colorInOut:getColor:=round((sTime/LifeTime)*(1-sTime/LifeTime)*4*(data.colorE-data.colorB)+data.colorB);
      colorRandom:getColor:=data.colorB+RandNum(data.ColorE-data.colorB,shotInd*3+5);
    end;
  end;

  function OshotsProfile.getSize(sTime,LifeTime:word):real;
  begin
    case data.sizeType of
      SizeConst:getSize:=data.size;
      SizeGrow:getSize:=data.size+Stime*data.sizeParam;
      SizeTime:getSize:=sTime;
      SizeCos:getSize:=data.size+cos(sTime/lifeTime*2)*data.sizeParam;
{      SizeTime:getSize:=sTime;}
{      SizeGrowInOut:
      SizeCos:}
    end;
    {round((1-sTime/LifeTime)*Size);}
  end;

  function OshotsProfile.getDemege(sTime,LifeTime:word):real;
  begin
    getDemege:=data.impEnemy.demege
  end;

  function OshotsProfile.getEnergy(sTime,LifeTime:word):real;
  begin
    getEnergy:=data.impEnemy.energy
  end;

  function OshotsProfile.getControl(sTime,LifeTime:word):real;
  begin
    getcontrol:=data.impEnemy.control
  end;

  procedure OshotsProfile.Draw(x,y,deg:real;shotInd,sTime,LifeTime:word;camera:Rcamera;ad:word);
  var
    color:byte;
    size:real;
  begin
    color:=round(getColor(shotInd,sTime,LifeTime));
    size:=getSize(sTime,lifeTime);
    case data.dispType of
      {DispNull}
      DispPixel:begin
        CameraPixel(camera,x,y,color,ad)
      end;

      DispDotCircle:begin
        CameraCir(camera,x,y,size,data.DispPara,deg,Color,ad);
      end;

      DispCircle:begin
        CameraCircle(camera,x,y,size,Color,ad);
      end;

      DispDotCirPara:begin
        CameraCir(camera,x,y,size,data.DispPara,deg+randReal(ShotInd)*2*pi,Color,ad);
      end;

      DispImpectExp:begin
        if(round(x) mod 4)= 0 then
          CameraCircle(camera,x,y,size,color,ad)
        else
          CameraCir(camera,x,y,size,data.DispPara,deg,color,ad)
      end;

      DispBall:begin
        CameraBall(camera,x,y,size/16,Color,ad);
      end;

      DispCircleOn:begin
        CameraCircleOn(camera,x,y,size,Color,ad);
      end;

    end;
  end;

  procedure OshotsProfile.initProfile2;
  begin
    data.sizeType:=SizeGrow;
    data.SizeParam:=0.25;
    data.Size:=0;
    data.ColorB:=40; data.colorE:=40; data.ColorMode:=ColorFade;
    data.TransOn[0,0]:=0;
    data.TransOn[0,1]:=0;
    data.TransOn[1,0]:=2;
    data.TransOn[1,1]:=0;
    data.transProb[0]:=0;
    data.transProb[1]:=0.15;
    data.degInit:=255;
    data.MoveType:=MoveNormal;
    data.LifeTimeMin:=10;
    data.LifeTimeRange:=10;
    data.MoveSpeed:=0;
{    data.DispPara:=0.25;}
    data.Physical:=TPhysical;
    data.impEnemy.Demege:=1;

    data.DispType:=DispCircle;
    data.ColorE:=0;
  end;

  procedure OshotsProfile.initProfile1;
  begin
    data.sizeType:=SizeTime;
    data.TransOn[0,0]:=0;
    data.TransOn[0,1]:=0;
    data.TransOn[1,0]:=0;
    data.TransOn[1,1]:=0;
    data.transProb[0]:=0;
    data.transProb[1]:=0;
    data.MoveType:=MoveNormal;
    data.colorMode:=ColorFade;
    data.colorB:=16*3-1;
    data.ColorE:=16*3-1;
    data.degInit:=255;
    data.LifeTimeMin:=25;
    data.LifeTimeRange:=10;
    data.MoveSpeed:=0;
    data.Physical:=TEffect;
    data.DispType:=DispImpectExp;
    data.ColorE:=0;
  end;

  procedure OshotsProfile.initProfile10; {smoke}
  begin
    { TransOn[0,0]:=1; {enum}
    { TransOn[0,1]:=2; {enum}
     data.TransOn[0,0]:=1; {enum}
     data.TransOn[0,1]:=1; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0;
     data.transProb[1]:=0;
     data. degInit:=0;
     data. DispType:=DispCircle; {chenge to enum}
     data. ColorB:=16*3+1; data.colorE:=16*4-8;data.ColorMode:=ColorInOut;
      {DispPara:=0; {*}

      data.Size:=1;
      data.SizeParam:=0.25;
      data.SizeType:=SizeGrow; {const,Grow,Change); {*} {change to enum}
      {Behevior}
      {movePara}
      data.LifeTimeMin:=25;
      data.LifeTimeRange:=0;

      data.Physical:=Teffect;{tPresistancet,...}
      data.impEnemy.Force:=0.1;

      data.MoveSpeed:=0.5;
      data.MoveType:=MoveNormal; {enum}
      data.MovePara:=0.05;
      data.impEnemy.Demege := 3;
      {data.DemegeType:=0; {* enum}

  end;


  procedure OshotsProfile.initProfile4;
  begin
     data.sizeType:=SizeTime;
     data.TransOn[0,0]:=1; {enum}
     data.TransOn[0,1]:=2; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=1;
     data.transProb[0]:=0.5;
     data.transProb[1]:=0.5;
     data. degInit:=255;
     data. DispType:=DispPixel; {chenge to enum}
     data. ColorB:=10; data.colorE:=40;data.ColorMode:=ColorInOut;

      data.Size:=1;
      data.SizeType:=SizeConst; {const,Grow,Change); {*} {change to enum}
      {Behevior}
      {movePara}
      data.LifeTimeMin:=35;
      data.LifeTimeRange:=40;

      data.Physical:=TPhysical;
      data.impEnemy.Force:=0.1;

      data.MoveSpeed:=2;
      data.MoveType:=MoveNormal; {enum}
      data.impEnemy.Demege := 0; {can be changed to make the die explotion demegeble}
      {data.DemegeType:=0; {* enum}

  end;


  procedure OshotsProfile.initProfile5;
  begin
     data.sizeType:=SizeTime;
     data.TransOn[0,0]:=1; {enum}
     data.TransOn[0,1]:=2; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0;
     data.transProb[1]:=0.5;
     data. degInit:=255;
     data. DispType:=DispDotCirPara; {chenge to enum}
     data. ColorB:=46; data.colorE:=10;data.ColorMode:=ColorFade;
     data. Size:=2;
      {Behevior}
      {movePara}
     data. LifeTimeMin:=65;
     data. LifeTimeRange:=0;
     data. Physical:=TEffect;
{     data. ForceOnEnemy:=0.1;}

     data. MoveSpeed:=0;
     data. MoveType:=MoveNormal; {enum}
{     data. Demege := 1;}
     {data. DemegeType:=0; {* enum}
{     data. ForceOnSelf:=0; {*}
  end;


  procedure OshotsProfile.initProfile6;
  begin
     data.TransOn[0,0]:=1; {enum}
     data.TransOn[0,1]:=1; {enum}
     data.TransOn[1,0]:=2; {end of life}
     data.TransOn[1,1]:=2;
     data.transProb[0]:=0;
     data.transProb[1]:=0;
     data. degInit:=0;
     data. DispType:=DispPixel; {chenge to enum}
     data. ColorB:=46; data.colorE:=15;data.ColorMode:=ColorFade;
      {DispPara:=0; {*}

      data.Size:=1;
      data.SizeType:=SizeConst; {const,Grow,Change); {*} {change to enum}
      {Behevior}
      {movePara}
      data.LifeTimeMin:=50;
      data.LifeTimeRange:=35;

      data.Physical:=TPhysical;
{      data.ForceOnEnemy:=0.1;}

      data.MoveSpeed:=2;
      data.MoveType:=MoveHoming; {enum}
      data.MovePara:=0.1;
{      data.Demege := 1;}
      {data.DemegeType:=0; {* enum}
{      data.ForceOnSelf:=0; {*}
  end;

  procedure OshotsProfile.initProfile7; {laser}
  begin
     data.TransOn[0,0]:=8; {enum}
     data.TransOn[0,1]:=0; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0.1;
     data.transProb[1]:=0;
     data. degInit:=0;
     data. DispType:=DispPixel; {chenge to enum}
     data. ColorB:=46; data.colorE:=30;data.ColorMode:=ColorFade;
      {DispPara:=0; {*}

      data.Size:=0;
      data.SizeType:=SizeConst; {const,Grow,Change); {*} {change to enum}
      {Behevior}
      {movePara}
      data.LifeTimeMin:=1;
      data.LifeTimeRange:=0;

      data.Physical:=Tphysical;
      data.impEnemy.Force:=0;

      data.MoveSpeed:=0;
      data.MoveType:=MoveNormal; {enum}
      data.MovePara:=0.1;

      data.impEnemy.demege:=0.1;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=0;
      data.impEnemy.control:=0;


      {data.Demege := 0.5;}
      {data.DemegeType:=0; {* enum}
{      data.ForceOnSelf:=0; {*}
  end;

  procedure OshotsProfile.initProfile8;
  begin
     data.TransOn[0,0]:=0; {enum}
     data.TransOn[0,1]:=0; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0;
     data.transProb[1]:=0;
     data. degInit:=0;
     data. DispType:=DispDotCircle; {chenge to enum}
     data. ColorB:=46; data.colorE:=30;data.ColorMode:=ColorInOut;
{     data. DispPara:=1; {*}

     data. Size:=0;
     data. SizeType:=SizeTime; {const,Grow,Change); {*} {change to enum}
     data. SizeParam:=0.5;
      {Behevior}
      {movePara}
     data. LifeTimeMin:=6;
     data. LifeTimeRange:=2;

      data.Physical:=TEffect;
{      data.ForceOnEnemy:=0;}

      data.MoveSpeed:=0;
      data.MoveType:=MoveNormal; {enum}
      data.MovePara:=0.1;
{      data.Demege := 0;}
      {data.DemegeType:=0; {* enum}
{      data.ForceOnSelf:=0; {*}
  end;

  procedure OshotsProfile.initProfile3Normal;
  begin
    { TransOn[0,0]:=1; {enum}
    { TransOn[0,1]:=2; {enum}
     data.dispPara:=11;
     data.TransOn[0,0]:=1; {enum}
     data.TransOn[0,1]:=1; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0.6;
     data.transProb[1]:=0;
     data. degInit:=30;


     data. DispType:=DispBall; {chenge to enum}

     data.SizeType:=SizeConst; {const,Grow,Change); {*} {change to enum}
     data.size:=2;

     data. ColorB:=16; data.colorE:=16*3-16;data.ColorMode:=ColorInOut;
      {DispPara:=0; {*}

      {Behevior}
      {movePara}
      data.LifeTimeMin:=75;
      data.LifeTimeRange:=20;

      data.Physical:=TPhysical;{tPresistancet,...}
{      data.ForceOnEnemy:=2;}

      data.MoveSpeed:=3;
      data.MoveType:=Movenormal; {enum}
{      data.MoveType:=MoveNormal; {enum}
      data.MovePara:=0.1;
      {data.MovePara:=0.08;}
      data.impEnemy.Demege := 4;
      data.impEnemy.Force := 0.3;
      {data.DemegeType:=0; {* enum}
{      data.ForceOnSelf:=0; {*}
  end;

  procedure OshotsProfile.initProfile11ExpBall;
  begin
    { TransOn[0,0]:=1; {enum}
    { TransOn[0,1]:=2; {enum}
     data.TransOn[0,0]:=0; {enum}
     data.TransOn[0,1]:=0; {enum}
     data.TransOn[1,0]:=0; {end of life}
     data.TransOn[1,1]:=0;
     data.transProb[0]:=0;
     data.transProb[1]:=0;
     data. degInit:=30;
     data. DispType:=DispBall; {chenge to enum}

     data.SizeType:=SizeGrow; {const,Grow,Change); {*} {change to enum}
     data.size:=2;
     data.SizeParam:=0.5;
{     data.DispPara:=0;}


     data. ColorB:=16; data.colorE:=16*2-5;data.ColorMode:=ColorFade;


      {Behevior}
      data.LifeTimeMin:=5;
      data.LifeTimeRange:=5;

      data.Physical:=Teffect;{tPresistancet,...}
{      data.ForceOnEnemy:=1;

      data.MoveSpeed:=0;
      data.MoveType:=MoveNormal; {enum}
      data.MovePara:=0.1;
      {data.MovePara:=0.08;}
{      data.Demege := 0;}
      {data.DemegeType:=0; {* enum}
{      data.ForceOnSelf:=0; {*}
  end;


  procedure OshotsProfile.initProParticles;
  begin
      {Display}
      data.DispType:=DispPixel; {Display Type - selects: pixel, circle, ball...}
      data.DispPara:=9; {Depending on Display Type, influens the display}

      data.ColorMode:=ColorFade; {can be random}
      data.ColorB:=16*4-1;
      data.colorE:=16*3+1;

      data.SizeType:=sizeConst; {const,Grow,Change); {*}
      data.Size:=1;
      data.SizeParam:=1;

      {Behevior}
      data.LifeTimeMin:=45;
      data.LifeTimeRange:=35;

      data.degInit:=255;
{      data.degInitGun:=255; {no need - remove varible add to gun}

      {impact}
      data.TransOn[0,0]:=0;
      data.TransOn[0,1]:=0;
      data.TransOn[1,0]:=0;
      data.TransOn[1,1]:=0;

      data.TransProb[0]:=0;
      data.TransProb[1]:=0;

      data.Physical:=Teffect;

      data.MoveSpeed:=0.5;
      data.MoveType:=MoveNormal;
      data.MovePara:=1;

      data.impEnemy.demege:=0;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=0;
      data.impEnemy.control:=0;
  end;

  procedure OshotsProfile.initProTurbo;
  begin
      {Display}
      data.DispType:=DispBall; {Display Type - selects: pixel, circle, ball...}
      data.DispPara:=9; {Depending on Display Type, influens the display}

      data.ColorMode:=ColorFade;
      data.ColorB:=30;
      data.colorE:=10;

      data.SizeType:=SizeGrow; {const,Grow,Change); {*}
      data.Size:=2;
      data.SizeParam:=-0.05;

      {Behevior}
      data.LifeTimeMin:=20;
      data.LifeTimeRange:=0;

      data.degInit:=0;
{      data.degInitGun:=0; {no need - remove varible add to gun}

      {impact}
      data.TransOn[0,0]:=0;
      data.TransOn[0,1]:=0;
      data.TransOn[1,0]:=0;
      data.TransOn[1,1]:=0;

      data.TransProb[0]:=0;
      data.TransProb[1]:=0;

      data.Physical:=Teffect;

      data.MoveSpeed:=0.3;
      data.MoveType:=MoveNormal;
      data.MovePara:=1;

      data.impEnemy.demege:=0;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=1;
      data.impEnemy.control:=0;
  end;

  procedure OshotsProfile.initControlJam;
  begin
      {Display}
      data.DispType:=DispDotCircle; {Display Type - selects: pixel, circle, ball...}
      data.DispPara:=9; {Depending on Display Type, influens the display}

      data.ColorMode:=ColorFade;
      data.ColorB:=25;
      data.colorE:=15;

      data.SizeType:=SizeGrow; {change to sinGlobalTime}
      data.Size:=5;
      data.SizeParam:=1;

      {Behevior}
      data.LifeTimeMin:=30;
      data.LifeTimeRange:=10;

      data.degInit:=255;
{      data.degInitGun:=255; {no need - remove varible add to gun}

      {impact}
      data.TransOn[0,0]:=0;
      data.TransOn[0,1]:=0;
      data.TransOn[1,0]:=0;
      data.TransOn[1,1]:=0;

      data.TransProb[0]:=0;
      data.TransProb[1]:=0;

      data.Physical:=Teffect;

      data.MoveSpeed:=0.3;
      data.MoveType:=MoveNormal;
      data.MovePara:=1;

      data.impEnemy.demege:=0;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=0;
      data.impEnemy.control:=0;
  end;


  procedure OshotsProfile.initProShild;
  begin
      {Display}
      data.DispType:=DispCircleOn; {Display Type - selects: pixel, circle, ball...}
      data.DispPara:=9; {Depending on Display Type, influens the display}

      data.ColorMode:=ColorFade;
      data.ColorB:=1;
      data.colorE:=1;

      data.SizeType:=SizeCos; {change to sinGlobalTime}
      data.Size:=9;
      data.SizeParam:=3;

      {Behevior}
      data.LifeTimeMin:=2;
      data.LifeTimeRange:=8;

      data.degInit:=0;
{      data.degInitGun:=0; {no need - remove varible add to gun}

      {impact}
      data.TransOn[0,0]:=0;
      data.TransOn[0,1]:=0;
      data.TransOn[1,0]:=0;
      data.TransOn[1,1]:=0;

      data.TransProb[0]:=0;
      data.TransProb[1]:=0;

      data.Physical:=Teffect;

      data.MoveSpeed:=0.3;
      data.MoveType:=MoveNormal;
      data.MovePara:=1;

      data.impEnemy.demege:=0;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=0;
      data.impEnemy.control:=0;
  end;

  procedure OshotsProfile.initProExpPart;
  begin
      {Display}
      data.DispType:=DispPixel; {Display Type - selects: pixel, circle, ball...}
      data.DispPara:=9; {Depending on Display Type, influens the display}

      data.ColorMode:=ColorFade; {can be random}
      data.ColorB:=16*3-1;
      data.colorE:=10;

      data.SizeType:=sizeConst; {const,Grow,Change); {*}
      data.Size:=1;
      data.SizeParam:=1;

      {Behevior}
      data.LifeTimeMin:=45;
      data.LifeTimeRange:=35;

      data.degInit:=255;
{      data.degInitGun:=255; {no need - remove varible add to gun}

      {impact}
      data.TransOn[0,0]:=1;
      data.TransOn[0,1]:=1;
      data.TransOn[1,0]:=1;
      data.TransOn[1,1]:=1;

      data.TransProb[0]:=0;
      data.TransProb[1]:=0;

      data.Physical:=Teffect;

      data.MoveSpeed:=2;
      data.MoveType:=MoveNormal;
      data.MovePara:=1;

      data.impEnemy.demege:=0;
      data.impEnemy.energy:=0;
      data.impEnemy.force:=0;
      data.impEnemy.control:=0;
  end;



begin
end.