{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}
unit k_math;
interface
 {max min}
  function absMin(value,positiveMin:real):real;

  {Degere}
{  function get_deg(x,y:real):real; {returns degree of x,y from -pi to pi}
  function deg_Diff(deg1,deg2:real):real;
  function deg_dis(deg1,deg2:real):real; {distance in radiuans}

{  function get_deg}
  function deg_sign(deg:real):integer; {the direction needed.. to }
  function deg_abs(deg:real):real; {distance in radiuans}
{  function deg_add(deg,add:real):real;}

  {Bit}
{  function Pow2}
  function pow2(pow:byte):word;
  function isPow2(num:word):boolean;
  function setBit(BitArray:word;ind:integer;val:boolean):word;
  function getBit(BitArray:word;ind:integer):boolean;
  function addBit(BitArray:word;ind:integer):word;
  function subBit(BitArray:word;ind:integer):word;

  {Probebelity}
  function bern(a:real):boolean;

  function rmod(x,y:real):real; {returns x rmod y}
  function rdiv(x,y:real):real; {returns x rdiv y}
implementation
  uses math_unt;

  function absMin(value,positiveMin:real):real;
  begin
    absMin:=min(abs(value),positiveMin)*sign(value);
  end;

  function deg_Diff(deg1,deg2:real):real;
  begin
    deg_diff:=deg_abs(deg2-deg1)*deg_sign(deg2-deg1);
  end;

  function pow2(pow:byte):word;
  begin
    pow2:=1 shl pow;
  end;

  function isPow2(num:word):boolean;
  begin
    isPow2:=((num and (num-1 shl 1))=0)and(num>0)or(num=1);
  end;

  function setBit(BitArray:word;ind:integer;val:boolean):word;
  begin
    if val then
      setBit:=addBit(BitArray,ind)
    else
      setBit:=subBit(BitArray,ind)
  end;

  function getBit(BitArray:word;ind:integer):boolean;
  begin
     getBit:=(BitArray or (1 SHL ind))=BitArray;
  end;

  function addBit(BitArray:word;ind:integer):word;
  begin
    addBit:=BitArray or (1 SHL ind);
  end;

  function subBit(BitArray:word;ind:integer):word;
  begin
    subBit:=BitArray and not(1 SHL ind);
  end;

  function deg_dis(deg1,deg2:real):real; {distance in radiuans}
  begin
      deg_dis:=abs(rmod(abs(deg1-deg2)+pi,2*pi)-pi);
  end;

  function deg_abs(deg:real):real; {distance in radiuans}
  begin
      deg_abs:=abs(rmod(abs(deg)+pi,2*pi)-pi);
  end;

  function deg_sign(deg:real):integer; {the direction needed.. to }
  begin
      deg_sign:=sign(deg)*sign(rmod(abs(deg)+pi,2*pi)-pi);
  end;

  function rmod(x,y:real):real; {returns x rmod y}
  begin
     rmod:=frac(x/y)*y;
  end;

  function rdiv(x,y:real):real; {returns x rdiv y}
  begin
    rdiv:=int(x/y);
  end;

  function bern(a:real):boolean;
  begin
     Bern:=random(65500)<a*65500;
  end;

begin

end.