unit K_Mem;
interface
type
OByteArray = Object
  data: ^Pointer;
  numOfBytes:word;
  ad:word;
  procedure open(numberOfBytes:word);
  procedure kill;
  function getE(index:word):byte;
  procedure setE(index:word;value:byte);
  procedure save(fileName:string);
  procedure load(fileName:string);
end;

OWordArray = Object
  Data:OByteArray;
  procedure open(numberOfElements:word);
  procedure kill;
  function getE(index:word):word;
  procedure setE(index:word;value:word);
  procedure incE(index:word);
{  procedure save(fileName:string);
  procedure load(fileName:string);}
end;

implementation
  procedure OByteArray.open(numberOfBytes:word);
  begin
     numOfBytes:=numberOfBytes;
     GetMem(data, SizeOf(Byte)*numOfBytes+10);
     ad:=Seg(data^);
  end;

  procedure OByteArray.kill;
  begin
    FreeMem(data, SizeOf(Byte)*numOfBytes+10);
    numOfBytes:=0;
    ad:=0;
  end;

  function  OByteArray.getE(index:word):byte;
  begin
     if index>=numOfBytes then halt;
     getE:=mem[ad:index]
  end;

  procedure OByteArray.setE(index:word;value:byte);
  begin
     if index>=numOfBytes then halt;
     mem[ad:index]:=value
  end;

  procedure OByteArray.save(fileName:string);
  var
    i:integer;
    fileData:file of byte;
    temp:byte;
  begin
    Assign(fileData,Filename);
    Rewrite(fileData);
    for i:=0 to numOfBytes-1 do
    begin
      temp:=getE(i);
      write(fileData,temp)
    end;
    Close(fileData)      {Closing file}
  end;

  procedure OByteArray.load(fileName:string);
  var
    i:integer;
    fileData:file of byte;
    temp:byte;
  begin
    Assign(fileData,Filename); {Opening the Font file}
    Reset(fileData);
    open(filesize(fileData)); {gets the file size}
    for i:=0 to numOfBytes-1 do
    begin
       read(fileData,temp);
       MEM[ad:i]:=temp
    end;
    Close(fileData)
  end;

  {********************************************************}

  procedure OWordArray.open(numberOfElements:word);
  begin
     data.open(numberOfElements*2);
  end;

  procedure OWordArray.kill;
  begin
     data.kill;
  end;

  function  OWordArray.getE(index:word):word;
  begin
       getE:=data.getE(index*2)+data.getE(index*2+1) Shl 8;
  end;

  procedure OWordArray.setE(index:word;value:word);
  begin
       data.setE(index*2,value and 255);
       data.setE(index*2+1,value Shr 8);
  end;

  procedure OWordArray.incE(index:word);
  begin

  end;

begin

end.