{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}
unit K_Sprite;
interface
uses k_mem;
const
  ss:array[-9..8,-5..5]of byte=
(
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,25,00,00,00,25,00,00,00),
(00,00,25,25,00,00,00,25,25,00,00),
(00,25,13,25,00,00,00,25,13,25,00),
(00,25,47,25,00,00,00,25,47,25,00),
(00,25,26,25,29,00,29,25,24,25,00),
(00,25,17,25,25,29,25,17,17,25,00),
(00,25,25,25,25,25,25,25,25,25,00),
(00,25,47,24,10,10,10,24,24,25,00),
(00,24,25,10,10,10,12,10,25,24,00),
(00,25,17,10,10,10,10,10,24,25,00),
(00,25,25,10,10,10,10,10,25,25,00),
(00,47,26,10,10,10,10,10,26,47,00),
(00,25,24,04,10,10,10,04,25,19,00),
(00,47,25,25,25,00,25,30,25,47,00),
(00,24,25,00,00,00,00,00,25,25,00),
(00,25,00,00,00,00,00,00,00,25,00),
(00,00,00,00,00,00,00,00,00,00,00));
Type
  RCamera = record
    x,y:real;
    zoom:real;
    ScreenX,ScreenY:integer;
  end;

  RSprite = Record
    SizeX,SizeY:word;
    rotateSize:word;
    CenterX,CenterY:word;
    {transCol}
    {colorRangeB,colorRangeE}
  end;

  OSprite = object
    data:OByteArray;
    s:RSprite;

    procedure open(inSizeX,inSizeY:word);
    procedure kill;

    function getColorCenter(x,y:integer):byte;
    function getColor(x,y:word):byte;
    procedure setColorCenter(x,y:integer;color:byte);
    procedure setColor(x,y:word;color:byte);
    procedure display(posx,posy:integer;ad:word);
    procedure CameraDisplay(camera:Rcamera;xp,yp:real;size:real;color:byte;ad:word);
    procedure CameraDisplayRot(camera:Rcamera;xp,yp:real;deg,size:real;color:byte;ad:word);
    procedure clear(color:byte);
    procedure temp(size:integer);
    procedure temp2;
    procedure temp3;
    procedure temp4(size:integer);
    procedure load(fileName:string);
    procedure save(fileName:string);


  end;

implementation
uses crt,mcga_vs,math_unt,math_bgs,mcga_fil;

Procedure bugPixel(X,Y: Integer; Color: Byte;ad:word);
begin
  if(ad = 0)or(X > 319)or(Y > 199)or(X < 0)or(Y <0)then halt;
  mem[ad:y shl 8+y shl 6+x]:=color;
End;

  procedure Osprite.temp3;
  var
    x,y:integer;
  begin
    for x:=-5 to 5 do for y:=-9 to 8 do
    if(ss[y,x]>12)and(ss[y,x]<>48)then setColorCenter(x,y,56+abs(x)+random(2));
    for x:=-5 to 5 do for y:=-9 to 8 do
    if(ss[y,x]>0)and(ss[y,x]<13)then setColorCenter(x,y,80-round(sqrt(x*x+y*y)))
  end;

  procedure Osprite.temp2;
  var
 i,j,x,y,length:integer;
 color:byte;
begin
    cls(50,vga);
    block_open('1.img',0,199,vga);
    for x:=0 to 80 do for y:=0 to 80 do
     if getpixel(x+6,y+4,vga)<>getpixel(1,1,vga) then
      setColor(x,y,getpixel(x+6,y+4,vga));;
{     delay(500);}

  end;

  procedure OSprite.temp(size:integer);
  var
    i,j,x,y,length:integer;
    color:byte;
  begin
{  clear(16*3+10);}
  size:=round(size);
  for i:= 1 to 100 do
  begin
       length:=2;
       x:=random((size-length)*2+1)+length;
       y:=random((size-length)*2+1)+length;
       color:=random(8)+16*3+3;
       for j:=-length to length do
       begin
         if random(2)=0 then
           setColor(x+j,y,color)
         else
           setColor(x,y+j,color);
       end;
    end;
{    for x:=-size to size do for y:=-size to size do
    begin
      if getColor(size+x,size+y)>0 then
      begin
        if sqr(x)+sqr(y)>sqr(size) then
          setColor(size+x,size+y,0)
        else
          setColor(size+x,size+y,round(
          max(getColor(size+x,size+y)+min(-sqrt(sqr(x)+sqr(y))+size-8,4),16*3+1) ));
      end;
    end;}
  end;

  procedure OSprite.temp4(size:integer);
  var
    i,j,x,y,length:integer;
    color:byte;
  begin
  clear(16*3+10);
  size:=round(size)+5;
    for i:= 1 to 3000 do
    begin
       length:=4;
       x:=random((size-length)*2+1)+length;
       y:=random((size-length)*2+1)+length;
       color:=random(8)+16*3+3;
       for j:=-length to length do
       begin
         if random(2)=0 then
           setColor(x+j,y,color)
         else
           setColor(x,y+j,color);
       end;
    end;
    size:=size-5;
    for x:=-size to size do for y:=-size to size do
    begin
      if getColor(size+x,size+y)>0 then
      begin
        if sqr(x)+sqr(y)>sqr(size) then
          setColor(size+x,size+y,0)
        else
          setColor(size+x,size+y,round(
          max(getColor(size+x,size+y)+min(-sqrt(sqr(x)+sqr(y))+size-8,4),16*3+1) ));
      end;
    end;
  end;

  procedure OSprite.open(inSizeX,inSizeY:word);
  begin
    s.sizeX:=inSizeX;
    s.sizeY:=insizeY;
    s.rotateSize:=round(max(s.sizeX,s.sizeY)/2*sqrt(2));
    data.open(s.sizeX*s.sizeY);
    s.centerX:=s.sizeX div 2;
    s.centerY:=s.sizeY div 2;
    clear(0);
  end;

  procedure OSprite.kill;
  begin
    data.kill;
  end;

  function Osprite.getColorCenter(x,y:integer):byte;
  begin
    getColorCenter:=getColor(x+s.centerX,y+s.centerY);
  end;

  function Osprite.getColor(x,y:word):byte;
  begin
    if(x<s.sizeX)and(y<s.sizeY)then
      getColor:=data.getE(x+y*s.sizeX)
    else
      getColor:=0;
  end;

  procedure Osprite.setColorCenter(x,y:integer;color:byte);
  begin
    setColor(x+s.centerX,y+s.centerY,color);
  end;

  procedure Osprite.setColor(x,y:word;color:byte);
  begin
    if(x<s.sizeX)and(y<s.sizeY)then
      data.setE(x+y*s.sizeX,color);
  end;

  procedure Osprite.display(posx,posy:integer;ad:word);
  var
    x,y:integer;
  begin
    for x:=0 to s.sizeX-1 do for y:=0 to s.sizeY-1 do
      limpixel(x+posX,y+posY,data.getE(x+y*s.sizeX),ad);
  end;

  procedure Osprite.CameraDisplay(camera:Rcamera;xp,yp:real;size:real;color:byte;ad:word);
    var
     x,y,limx,limy:integer;
     indx,tx,indy,ty:integer;
     col:byte;
     de,rad:real;
  begin

    xp:=xp/camera.zoom-camera.x+160; {change to screen}
    yp:=yp/camera.zoom-camera.y+100;
    limX:=round(s.SizeX/2/camera.zoom); {needs to be changed}
    limY:=round(s.SizeY/2/camera.zoom); {needs to be changed}
    for indX:=round(max(xp-limX,0)) to round(min(xp+limX,319)) do
    for indY:=round(max(yp-limY,0)) to round(min(yp+limY,199)) do
    begin
      x:=round(indX-xp);
      y:=round(indY-yp);
      col:=getColorCenter(round(x*camera.zoom),round(y*camera.zoom));
      if col>0 then
        putPixel(round(xp+x),round(yp+y),col,ad)
      else
        BugPixel(round(xp+x),round(yp+y),100,ad);
    end;
  end;

  procedure Osprite.CameraDisplayRot(camera:Rcamera;xp,yp:real;deg,size:real;color:byte;ad:word);
  var
     x,y,lim:integer;
     indx,tx,indy,ty:integer;
     col:byte;
     de,rad:real;
  begin

    xp:=xp/camera.zoom-camera.x+160; {change to screen}
    yp:=yp/camera.zoom-camera.y+100;
    lim:=round(s.rotateSize/camera.zoom);

    for indX:=round(max(xp-lim,0)) to round(min(xp+lim,319)) do
    for indY:=round(max(yp-lim,0)) to round(min(yp+lim,199)) do
    begin
      x:=round(indX-xp);
      y:=round(indY-yp);
      De:=getdeg1(x,y);
{      rad:=sqrt(sqr(y)+sqr(x))*camera.zoom;}
      rad:=getRad(x,y)*camera.zoom;
      col:=getColorCenter(round(rad*cos(de-deg))
      ,round(rad*sin(de-deg)));
      if col>0 then
        putPixel(round(xp+x),round(yp+y),col,ad)
{      else
        BugPixel(round(xp+x),round(yp+y),100,ad);}
    end;
  end;

  procedure Osprite.clear(color:byte);
  var
    x,y:word;
  begin
    for x:=0 to s.sizeX-1 do for y:=0 to s.sizeY-1 do
    begin
      setColor(x,y,color);
    end;
  end;

  procedure Osprite.load(fileName:string);
  var
    dataFile:File of RSprite;
  begin
    Assign(dataFile,fileName+'.spr');
    Reset(dataFile);
    read(dataFile,s);
    Close(dataFile);

    data.load(fileName+'.img');
  end;

  procedure Osprite.save(fileName:string);
  var
    dataFile:File of RSprite;
  begin
    Assign(dataFile,fileName+'.spr');
    Rewrite(dataFile);
    write(dataFile,s);
    Close(dataFile);

    data.save(fileName+'.img');
  end;

begin
  randomize;

end.