{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}
unit Math_BGS;
interface
  function smart_bg(bg1,bg2:byte;x,y,bgs,deg_in,time,zoom,zoom_c,frec,spiral:real):real;
  function math_bg(num:byte;x,y:real):real;
  function GetDeg1(xm,ym:integer):real;
  function getRad(x,y:integer):real;
implementation
uses math_unt;
var
  x,y:integer;
  getd:array[-40..40,-40..40]of integer; {change to dynmacliy alocated}
  RadLookUp:array[0..20,0..20]of real;

  function GetDegR(xm,ym:integer):real;
  begin
    if xm>0 then
    getdegR:=arctan(ym/xm)+2*pi;
    if xm<0 then
    getdegR:=arctan(ym/xm)+pi;
    if(xm=0)and(ym>0)then getdegR:=pi/2;
    if(xm=0)and(ym<0)then getdegR:=-pi/2;
  end;

  function getRad(x,y:integer):real;
  begin
     x:=abs(x);
     y:=abs(y);
     if(x<=20)and(y<=20)then
       getRad:=radLookUp[x,y]
     else
       getrad:=sqrt(sqr(x)+sqr(y));
  end;

  function GetDeg1(xm,ym:integer):real;
  begin
{     xm:=abs(xm);
     ym:=abs(ym);}
     if(abs(xm)<=20)and(abs(ym)<=20)then
        getDeg1:=getd[xm,ym]/2048*pi
     else
       getDeg1:=getDegR(xm,ym);
  end;
 function smart_bg(bg1,bg2:byte;x,y,bgs,deg_in,time,zoom,zoom_c,frec,spiral:real):real;
 var
   deg,rad,dx,dy,res1,res2:real;
 begin
    if abs(deg_in)>0.05 then
    begin
      rad:=sqrt(sqr(x)+sqr(y));
      deg:=getdeg(x,y);
      x:=rad*cos(deg+deg_in+rad*spiral);
      y:=rad*sin(deg+deg_in+rad*spiral);
    end;
    if abs(zoom_c)>0.01 then
    begin
      dx:=cos(sin(time/10)*10+y*frec)*zoom_c;
      dy:=sin(cos(time/10)*10+x*frec)*zoom_c;
    end
    else
    begin
      dx:=0;
      dy:=0;
    end;
    res1:=0;
    res2:=0;
    if bgs>0 then
    res1:=math_bg(bg1,x*zoom+dx,y*zoom+dy);
    if bgs<1 then
    res2:=math_bg(bg2,x*zoom+dx,y*zoom+dy);
    smart_bg:=bgs*res1+(1-bgs)*res2;
 end;

  function math_bg(num:byte;x,y:real):real;
  begin
    case num of
      0:math_bg:=0;
      1:math_bg:=(arctan(sin(x/(sin(y/20)*2+10))*4)+arctan(sin(y/(sin(x/20)*2+10))*4))/2.652;
      2:math_bg:=(arctan(sin(y/(cos(x/10)*5+10))*5)+arctan(sin(x/(sin(y/10)*5+10))*5))/2.747;
      3:math_bg:=(sin(y/(cos(x/(sin(y/25)*5+10))*5+10))+sin(x/(sin(y/(cos(x/25)*5+10))*5+10)))/2;
      4:math_bg:=(sin(x/(sin(y/10)*5+10)+y/(cos(x/10)*5+10))
      +sin((320-x)/(sin(y/10)*5+10)+(199-y)/(cos(x/10)*5+10)))/2;
      5:math_bg:=(sin(x/(sin(y/10)*5+10))*6+sin(y/(cos(x/10)*5+10))*6)/12;
      6:math_bg:=(sin(x/(sin(y/10)*5+10)+y/(cos(x/10)*5+10))*15)/15;
      7:math_bg:=(sin(x/(arctan(sin(y/20)*5)*4+10))*10+sin(y/(arctan(sin(x/20)*5)*4+10))*10)/20;
      8:math_bg:=cos(x/(sin(y/10)*5+10))*cos(y/(sin(x/10)*5+10));
      9:math_bg:=(sin(y/(cos(x/(sin(y/25)*5+10))*5+10))+sin(x/(sin(y/(cos(x/25)*5+10))*5+10))*10)/11;
      10:math_bg:=(sin(x/(sin(y*y/15)*3+10))*10+sin(y/(sin(x*x/15)*3+10))*10)/20;
      11:math_bg:=randnum(60000,round(x)+round(y)*320)/60000;
      12:math_bg:=sqrt(sqr(x)+sqr(y))/188; {**}
      13:math_bg:=max(abs(x),abs(y))/188; {**}
      14:math_bg:=(abs(x)+abs(y))/188; {**}
      15:math_bg:=((abs(round(x)) and 255)xor(abs(round(y)) and 255))/128-1;
      16:math_bg:=((abs(round(x)) and 255)or(abs(round(y)) and 255))/128-1;
      17:math_bg:=((abs(round(x)) and 255)and(abs(round(y)) and 255))/128-1;
      18:math_bg:=cos(getdeg(x,y)*5);
      19:if sign(cos(getdeg(x,y)*20))=1 then math_bg:=1 else math_bg:=-1;
      20:math_bg:=cos(Y/10+sin(x/17));
      21:if sign(cos(Y/10+sin(x/17)))=1 then math_bg:=1 else math_bg:=-1;
      22:math_bg:=sin(sqrt(sqr(x/5)+sqr(y/5)));
      23:if sign(sin(sqrt(sqr(x/5)+sqr(y/5))))=1 then math_bg:=1 else math_bg:=-1;
      else math_bg:=cos(x*y);
    end;
  end;
begin
  for x:=-40 to 40 do for y:=-40 to 40 do
    getd[x,y]:=round(getdegR(x,y)/pi*2048);
  for x:=0 to 20 do for y:=0 to 20 do
    RadLookUp[x,y]:=sqrt(sqr(x)+sqr(y));
end.