{************************************************
 * Mcga_fnt - advenced font unit by Kobi Nistel *
 ************************************************
 Quick start:
 Font modes:
 +1 - rghit to left
 +2 - flips verticly
 +4 - flips x and y
 +8 - adds text ON screen
 +16 - fat text
 +32 - shade text
 +64 - color Fx
 +128 - color Fx

 1) Ver 0.01 - 8X8 fonts
 2) Use & sturcture: this unit is used to load and use font in *.knf format
 the unit read the font data to memory (every letter uses 8 bytes of memory)
 How To Use : Load fonts by using "load_font" function:
 font_address:=Load_font('name.knf',returnd_size,Pointer);
 the function allocates memory and loads the font data returnig the address
 and size of the memory alocated,In the end of the program colse the font
 to free the memorey by using "close_font": close_font(size,pointer);.
 to print use puttext('text',xpos,ypos,space,color,ad_f,ad);
 xpos,ypos - are the postion of the upper left corner of the text.
 space - the space betwaen letters in pixels.
 color - the color of the font text.
 ad_f - the address of the fonts, you can load more then one font...
 ad - the address of the screen the font is printed on.
 (all 'put...' functions returns the size of the prinded text in pixels.
 if the color is negetive the functions dose not putpixels,
 and you can use id to get the size of the text only)
 3) Units in use: CRT - readkey in use of "getstring"
 4) Constants: SPACE_KEY = #32; BEACKSPACE_KEY = #8;
 5) Global varibels:
 SIZEX,SIZEY - hold the magnefication of the font
 MINX...
 6) Reset:
 SIZEX:=1; SIZEY:=1;
 7) Files:
 Name: *.knf
 structure: HHH|SEG|SEG|...|1st_NOTE|2nd_NOTE|...
 Head(size:3 bytes):
 0: hold the number of charcters in the font
 1: hold the number of pixels moved in space
 2: hold the number of segments;
 Segments(size:3 x Number of segmebts - (3*mem[ad_f:2]) bytes):
 0: the the begining of the segmant
 1: the end of the segment
 2: the substruction from the segment
 font data (size:8 x number of charcters -(8*mem[ad_f:0]) bytes):
 1-8: ech byte hold a row of 8 pixels,8 bytes (rows) hold a cherectr 8x8.
}
unit mcga_fnt;
interface

  {Suproting functions - made public for advanced use}
  procedure textpixel(xp,yp,xr,yr: integer; color: integer;ad:word);
  function char2num(ch:char;ad_f:word):integer;
  function putnote(let:char;xpos,ypos:integer;color:integer;ad_f,ad:word):byte;
  {Loading and closing fonts}
  function load_font(filename:string;var VM:pointer):word;
  procedure close_font(VM:pointer); {to remove size}
  {The basic functions}
  function puttext(s:string;xpos,ypos,space:integer;color:integer;ad_f,ad:word):integer;
  function putnum(num:real;Width,Decimals,xpos,ypos,space:integer;color:integer;ad_f,ad:word):integer;
  function midtext(s:string;xmin,xmax,ypos,space:integer;color:integer;ad_f,ad:word):integer;
  function readstring(xpos,ypos,space:integer;max:byte;col:integer;ad_f,ad:word):string;
  function invalid_str(s:string;ad_f:word):byte;
  procedure setFontSpace(space:byte;ad_f:word);
  {Global varibles functions - this functions fx all loaded fonts}
  procedure setFontSize(xs,ys:byte);
  procedure setFontWindow(miX,miY,MaX,MaY:integer);
  procedure setFontMODE(stl:byte);
  procedure setFontBcolor(color:byte);
Implementation
  Uses CRT,
       Math_unt;
  Const
     SPACE_KEY = ' ';
     BACKSPACE_KEY = chr(8);

     SAFE = 5;
  var
    SIZEX,SIZEY,MODE,B_COLOR:byte;
    MINX,MINY,MAXX,MAXY:integer;

    {************************* Inner functions **********************}
    Procedure pixel(X,Y: Integer; Color: integer;ad:word);
    begin
      if ad = 0 then exit;
      if X > maxx then exit;
      if Y > maxy then exit;
      if X < minx then exit;
      if Y < miny then exit;
      if(btb(MODE,3))then
         mem[ad:y*320+x]:=mem[ad:y*320+x]+color
      else
         mem[ad:y*320+x]:=color;
    End;

    function colorfx(select:byte;x,y:integer):integer;
    begin
      case select of
        0:colorfx:=0;
        1:colorfx:=x+y;
        2:colorfx:=y;
        3:colorfx:=round(sin(x+y)*2)+2;
      end;
    end;


    {puts a pixel on the screen in MCGA,function is in use of 'putnote'}
    procedure textpixel(xp,yp,xr,yr: integer; color: integer;ad:word);
    var
      x,y,i:integer;
    begin
      if(btb(MODE,0))then xp:=MAXX-xp;
      if(btb(MODE,1))then yp:=MAXY-yp;
      if(btb(MODE,2))then flipNum(xp,yp);

      for x:=0 to SIZEX-1 do for y:=0 to SIZEY-1 do
      begin
        pixel(x+xp,y+yp,color+sign(color)*colorfx((MODE and 192) shr 6,xr,yr),ad);
        if(btb(MODE,4))then
        for i:=0 to 3 do
         pixel(x+xp+(i mod 2)*((i div 2)*2 -1),y+yp+((i+1) mod 2)*((i div 2)*2 -1),
         color+sign(color)*colorfx((MODE and 192) shr 6,xr,yr),ad);
      end;
    End;
    {**********************Supporting Functions ************************}
    {convers a char to a number wich is the order of the char in the font
    returns -1 if the cher is in no segment}
    function char2num(ch:char;ad_f:word):integer;
    var
        char_num:integer;
        i:integer;
    begin
        char_num:=-1;
        if(ch=SPACE_KEY)then char_num:=0 {**}
        else
        for i:=1 to mem[ad_f:2] do  {Num of Segments}
          if(ord(ch)>=mem[ad_f:i*3])and(ord(ch)<=mem[ad_f:i*3+1])then
            char_num:=ord(ch)-mem[ad_f:i*3+2];
        char2num:=char_num;
    end;
    {prints a char on the screen}
    function putnote(let:char;xpos,ypos:integer;color:integer;ad_f,ad:word):byte;
    var
      x,y,let_size:byte;
      shift:word;
      let_num:integer;
    begin
      let_size:=0;
      if let<>SPACE_KEY then
      begin
        shift:=mem[ad_f:2]*3+3;
        let_num:=char2num(let,ad_f);
        if(let_num>=0) then
        for x:=0 to 7 do
          for y:=0 to 7 do
           if(btb(MEM[ad_f:let_num*8+x+shift],y))then
           begin
             let_size:=x+1;
             if(btb(MODE,5))then textpixel(xpos+(x+1)*SIZEX,ypos+(y+1)*SIZEY,x,y,B_Color*sign(color),ad);
             textpixel(xpos+x*SIZEX,ypos+y*SIZEY,x,y,color,ad);
           end;
      end
      else let_size:=MEM[ad_f:1];
      putnote:=let_size*SIZEX;
    end;


    function getFontSize(letnum,segnum:byte):word;
    begin
      {charcter number X 8 + segment number X 3 + head size(3)}
      getFontsize:=letnum*8+segnum*3+3+safe;
    end;

  {******************Begining of Font related functions**********************}
    function load_font(filename:string;var VM:pointer):word;
     var   {function is used to load a font from a file to memory}
       i:integer;
       letnum,space,segnum,temp:byte;
       data:file of byte;
       ad_f:word;
       FontSize:word;
       Fsize:longint;
    begin
      Assign(data,Filename); {Opening the Font file}
      Reset(data);
      read(data,letnum);
      read(data,space);
      read(data,segnum);

      FontSize:=GetFontsize(letnum,segnum);
      fsize:=filesize(data); {gets the file size for use in the closing}
      GetMem (VM,FontSize);   {allocates the memory for the fonts}
      ad_f := seg(VM^);   {assing the addres in 'ad_f}
      mem[ad_f:0]:=letnum;
      mem[ad_f:1]:=space;
      mem[ad_f:2]:=segnum;
      fsize:=round(min(fsize,FontSize));
      for i:=0 to fsize-4 do  {loading the Font Data in to memory from the file}
      begin
        read(data,temp);
        MEM[ad_f:i+3]:=temp;
      end;
      Close(data);      {Closing file}
      load_font:=ad_f;
    end;

    {uesd to free memory after font use}
    procedure close_font(VM:pointer);
    begin
      FreeMem(VM,getFontsize(mem[seg(vm^):0],mem[seg(vm^):2]));
    end;


    {prints text on screen}
    function puttext(s:string;xpos,ypos,space:integer;color:integer;ad_f,ad:word):integer;
    var
      i,pos:integer;
    begin
      pos:=0;
      for i:=1 to length(s) do
        pos:=pos+space+putnote(s[i],xpos+pos,ypos,color,ad_f,ad);
      puttext:=pos-space;
    end;
    {prints a number on screen}
    function putnum(num:real;Width,Decimals,xpos,ypos,space:integer;color:integer;ad_f,ad:word):integer;
    var
      s:string;
    begin
      str(num:Width:Decimals,s);
      putnum:=puttext(s,xpos,ypos,space,color,ad_f,ad);
    end;

    function midtext(s:string;xmin,xmax,ypos,space:integer;color:integer;ad_f,ad:word):integer;
     var
       tsize:integer;
    begin
      tsize:=puttext(s,0,0,space,0,ad_f,0);
      midtext:=puttext(s,(xmin+xmax-tsize)div 2,ypos,space,color,ad_f,ad);
    end;


    function readstring(xpos,ypos,space:integer;max:byte;col:integer;ad_f,ad:word):string;
    var
      s:string;
      pos:integer;
      m_space:byte;
      ch:char;
    begin
      s:='';
      pos:=0;
      m_space:=0;
      repeat
        textpixel(xpos+pos+3*sizex,ypos+3*sizey,0,0,col,ad);
        ch:=readkey;
        if(btb(MODE,3))then
          textpixel(xpos+pos+3*sizex,ypos+3*sizey,0,0,-col,ad)
        else
          textpixel(xpos+pos+3*sizex,ypos+3*sizey,0,0,B_COLOR,ad);
        if(char2num(ch,ad_f)>=0)and(Length(s)<max)then
        begin
          m_space:=putnote(ch,xpos+pos,ypos,col,ad_f,ad)+space;
          pos:=pos+m_space;
          s:=Concat(s,ch);
        end;
        if(ch=BACKSPACE_KEY)and(Length(s)>0)then
        begin
          pos:=pos-putnote(s[Length(s)],1,1,0,ad_f,0)-space;
          if(btb(MODE,3))then
            putnote(s[Length(s)],xpos+pos,ypos,-col,ad_f,ad)
          else
            putnote(s[Length(s)],xpos+pos,ypos,B_COLOR,ad_f,ad);
          Delete(s,Length(s),1);
        end;
      until ch=#13;
      readstring:=s;
    end;

    function invalid_str(s:string;ad_f:word):byte;
    var
     n:byte;
    begin
      n:=0;
      repeat
        n:=n+1;
      until(char2num(s[n],ad_f)<0)or(n=length(s));
      if(n=length(s))and(char2num(s[n],ad_f)>=0)then
        invalid_str:=0
      else
        invalid_str:=n;
    end;

    procedure setFontSpace(space:byte;ad_f:word);
    begin
      MEM[ad_f:1]:=space;
    end;

    procedure setFontsize(xs,ys:byte);
    begin
      SIZEX:=xs;
      SIZEY:=ys;
    end;

    procedure setFontWindow(miX,miY,MaX,MaY:integer);
    begin
      if(miX<0)then MINX:=0
      else MINX:=miX;
      if(miY<0)then MINY:=0
      else MINY:=miY;
      if(MaX>319)then MAXX:=319
      else MAXX:=MaX;
      if(MaY>199)then MAXY:=199
      else MAXY:=MaY;
    end;

    procedure setFontBcolor(color:byte);
    begin
      B_COLOR:=color;
    end;

    procedure setFontMODE(stl:byte);
    begin
      MODE:=STL;
    end;

begin
  SIZEX:=1;
  SIZEY:=1;
  MINX:=0;
  MINY:=0;
  MAXX:=319;
  MAXY:=199;
  MODE:=0;
  B_COLOR:=0;
end.