{******************** Mcga Project ******************
 * Mcga_gui 1.01 - Graphics User Interface unit     *
 * made by: Kobi Nistel as part of the mcga project *
 * E-mail: nis.kobi@gmail.com                       *
 ****************************************************
 1) Ver 1.01
 2) Use & sturcture: this unit is used to help make a GUI:
 the unit can read buttens form a file to memory,
 paint them on screen and check if somthing is on them
 given its position.
 3) Units in use: math_unt(mathematical unit).
 4) Constants: X_ONE=1; Y_ONE=2; X_TWO=3; Y_TWO=4; C_SHAPE=5;
 5) Golbal varibels: STYLE - hold the style of the butten frame
 6) Reset: STYLE:=3;
 7) Files:
 Name:GUI Format *.gui
 (hold buttens by two points(x,y 4-bytes) and shape(1-byte)
 Structure: N,Ox,Oy|X1,Y1,X2,Y2,S|X1,Y1,X2,Y2,S|.........|
 Head(size:5 bytes):
 0: holds the number of buttens
 1-2: holds the origen_x; (this is the point of reffrns to all buttens...)
 3-4: holds the origen_y; (...if moved the all group of buttens is moved)
 buttens(size:9 x Number of buttens bytes):
 0-1: holds x1;
 2-3: holds y1;
 4-5: holds x2;
 6-7: holds y2;
 8:   holds the Shape of the butten;
 Total size:5+9*(butten number)=5+9*mem[ad_gui:0];

 Name:STYLE Format *.stl
 (holds buttens visual style, by frames,color_vec,color,style)
 Structure: N|STLE||STLE||STLE
 Head(size:1 byte):
 0: holds the number of butten styles;
 Style(size:4* number of styles ,in bytes)
 1:frmaes
 2:color vector
 3:color
 4:style
 Total size:1+4*style number;
}

  unit mcga_gui;
  interface

    function getGUIsize(but_num:byte):word;
    function getSTLsize(but_num:byte):word;
    {*******************Loading and memory functions**********************}
    {allocates memory for but_num buttens in the GUI format,mem=5+but_num*9}
    function  get_GUI_mem(but_num:byte;var VM:pointer):word;
    {allocates memoery and read a file in to it}
    function load_gui(filename:string;var VM:pointer):word;
    {frees memory}
    procedure closeGui(VM:pointer);
    {saves GUI format buttens in to a file}
    function get_stl_mem(but_num:byte;var VM:pointer):word;
    function load_stl(filename:string;var VM:pointer):word;
    procedure closeSTL(VM:pointer);
    procedure Save_gui(filename:string;ad_gui:word);
    {************************General functions******************************}
    {sets the Origen (offset) of a butten group}
    procedure SetOrigen(NX,NY:integer;ad_gui:word);
    {gets the Origen (offset) of a butten group}
    procedure GetOrigen(var NX,NY:integer;ad_gui:word);
    {sets the style of the shade of the butttens}
    procedure SetGuiStyle(st:byte);
    {gets the number of buttens of a butten group}
    function  Get_but_num(ad:word):byte;
    {sets the number of buttens of a butten group,Warrnig!! you must
    at get_gui_mem allocate memory for the maximal buttens you gonna use}
    procedure set_but_num(num:byte;ad:word);
    {sets the value using get_Gindex of a butten in GUI format}
    procedure set_Bval(b_num,data_i:byte;val:word;ad_gui:word);
    {gets the value using get_Gindex of a butten in GUI format}
    function  get_Bval(b_num,data_i:byte;ad_gui:word):longint;
    {sets a butten values in GUI format}
    procedure set_but(b_num:integer;x1,y1,x2,y2:word;shape:byte;ad_gui:word);
    procedure get_but(b_num:integer;var x1,y1,x2,y2:integer;var shape:byte;ad_gui:word);
    function  set_stl(b_num,frames,f_cvec:integer;col,style:byte;ad_stl:word):boolean;
    function  get_stl(b_num:integer;var frames,f_cvec:integer;var col,style:byte;ad_stl:word):boolean;
    {*************************Control functions***************************}
    {checks if (xb,yb) is in the shape deffind by (x1,y1) (x2,y2) and shape}
    function  on_the(xb,yb,x1,y1,x2,y2:integer;shape:byte):boolean;
    {checks if (xm,ym) is on a butten number num }
    function  a_butten(num:byte;xm,ym:integer;ad_gui:word):boolean;
    {give the number of the last butten in wich (xm,ym) is on}
    function  get_butten(xm,ym:integer;ad_gui:word):byte;
    {returns in bits all the status of the 16 first buttens thet(xm,ym)is on}
    function  get_buttens(xm,ym:integer;ad_gui:word):word;
    {*************************Graphics functions***************************}
    {paint only butten number num to screen addres ad}
    procedure paint_a_but(num:byte;ad_gui:word;frames,f_cvec:integer;col:byte;ad_vs:word);
    {paints all buttens in memory (ad_gui)to the screen in addres ad}
    procedure paint_gui(ad_gui:word;frames,f_cvec:integer;col:byte;ad_vs:word);
    {paints a butten in position (x1,y1) (x2,y2) in shape....}
    procedure ShapeWindow(x1,y1,x2,y2,shape,frames,f_cvec:integer;col:byte;ad_vs:word);
    {paints gui reading style from a file}
    procedure paint_stl(name:string;ad_gui:word;ad_vs:word);
    {paints gui reading style from memorey}
    procedure paint_stl_ad(ad_stl:word;ad_gui:word;ad_vs:word);
    {paints buttens a to b form gui reading style from memorey}
    procedure P_stl(a,b:integer;ad_stl:word;ad_gui:word;ad_vs:word);
    {press butten}
    procedure FlipCvec(butNum:byte;ad_stl:word);
    procedure setStlColor(butNum,color:byte;ad_stl:word);
    function getStlColor(butNum:byte;ad_stl:word):byte;
    procedure GuiPressBut(butNum:byte;color:integer;ad_stl:word);
    function getCvecSign(butNum:byte;ad_stl:word):integer;
    Procedure putbar(x1,y1,x2,y2:integer;col:byte;ad_vs:word);
    Procedure putSframe(x1,y1,x2,y2,i,frames,f_cvec:integer;col:byte;ad_vs:word);{?}
    procedure GetButCent(num:byte;var x,y:integer;ad_gui:word);
    function getButXc(num:byte;ad_gui:word):integer;
    function getButYc(num:byte;ad_gui:word):integer;

    Const
      X_ONE=1;
      Y_ONE=2;
      X_TWO=3;
      Y_TWO=4;
      C_SHAPE=5;

      SAFE=8;
  Implementation
  uses math_unt;
  var
    STYLE:byte; {this was in retrospect a mistake}


  {************************Loading and memory functions******************}
  function getGUIsize(but_num:byte):word;
  begin
    getGUIsize:=5+but_num*9+SAFE;
  end;

  function getSTLsize(but_num:byte):word;
  begin
    getSTLsize:=1+but_num*4+SAFE;
  end;

  procedure  Set_but_num(num:byte;ad:word);
  begin
    mem[ad:0]:=num;
  end;

  function  Get_but_num(ad:word):byte;
  begin
    get_but_num:=mem[ad:0];
  end;

    function get_GUI_mem(but_num:byte;var VM:pointer):word;
    var
      ad_gui,i:word;
    begin
      GetMem (VM,getGUIsize(but_num));   {allocates the memory for the fonts}
      ad_gui:=seg(VM^);
      set_but_num(but_num,ad_gui);
      setOrigen(0,0,ad_gui);
      for i:=5 to getGUIsize(but_num)-SAFE-1 do mem[ad_gui:i]:=0;
      get_GUI_mem := ad_gui;   {assing the addres}
    end;

    function load_gui(filename:string;var VM:pointer):word;
     var   {function is used to load a font from a file to memory}
       i:integer;
       temp:byte;
       data:file of byte;
       ad_f:word;
       GuiSize:word;
       Fsize:longint;
    begin
      Assign(data,Filename); {Opening the Font file}
      Reset(data);
      read(data,temp);
      GuiSize:=GetGUIsize(temp);
      fsize:=filesize(data); {gets the file size for use in the closing}
      GetMem (VM,GuiSize);   {allocates the memory for the fonts}
      ad_f := seg(VM^);   {assing the addres in 'ad_f}
      Fillchar(mem [ad_f:0],GuiSize,0);
      Set_but_num(temp,ad_f);{***}
      fsize:=round(min(fsize,GuiSize));
      for i:=1 to fsize-1 do  {loading the Font Data in to memory from the file}
      begin
        read(data,temp);
        MEM[ad_f:i]:=temp;
      end;
      Close(data);      {Closing file}
      load_gui:=ad_f;
    end;

    procedure closegui(VM:pointer);
    begin
      FreeMem(VM,getGUIsize(get_but_num(seg(VM^))));
    end;

    function get_stl_mem(but_num:byte;var VM:pointer):word;
    var
      ad_stl,i:word;
    begin
      GetMem (VM,getSTLsize(but_num));   {allocates the memory for the fonts}
      ad_stl:=seg(VM^);
      set_but_num(but_num,ad_stl);
      setOrigen(0,0,ad_stl);
      for i:=5 to getSTLsize(but_num)-SAFE-1 do mem[ad_stl:i]:=0;
      get_STL_mem := ad_stl;   {assing the addres}
    end;

    function load_stl(filename:string;var VM:pointer):word;
     var   {function is used to load a font from a file to memory}
       i:integer;
       temp:byte;
       StlSize:word;
       data:file of byte;
       ad_f:word;
       size:longint;
    begin
      Assign(data,Filename); {Opening the Font file}
      Reset(data);
      read(data,temp);
      StlSize:=GetSTLsize(temp);
      size:=filesize(data); {gets the file size for use in the closing}
      GetMem (VM,StlSize);   {allocates the memory for the fonts}
      ad_f := seg(VM^);   {assing the addres in 'ad_f}
      Fillchar(mem [ad_f:0],StlSize,0);
      mem[ad_f:0]:=temp;
      size:=round(min(size,StlSize));
      for i:=1 to size-1 do  {loading the Font Data in to memory from the file}
      begin
        read(data,temp);
        MEM[ad_f:i]:=temp;
      end;
      Close(data);      {Closing file}
      load_STL:=ad_f;
    end;

    procedure closeSTL(VM:pointer);
    begin
      FreeMem(VM,getSTLsize(get_but_num(seg(VM^))));
    end;

   procedure Save_gui(filename:string;ad_gui:word);
    var   {saves a segment of memory to file}
       i:integer;
       temp:byte;
       data:file of byte;
       size:word;
    begin
      size:=getGUIsize(mem[ad_gui:0])-safe;
      Assign(data,Filename); {Opening the Font file}
      Rewrite(data);
      for i:=0 to size-1 do  {loading the Font Data in to memory from the file}
      begin
        temp:=mem[ad_gui:i];
        write(data,temp);
      end;
      Close(data);      {Closing file}
    end;


  {***************Global varibles and general use functions*******************}
  procedure SetOrigen(NX,NY:integer;ad_gui:word);
  begin
    memw[ad_gui:1]:=int2word(NX);
    memw[ad_gui:3]:=int2word(NY);
  end;

  procedure GetOrigen(var NX,NY:integer;ad_gui:word);
  begin
    NX:=word2int(memw[ad_gui:1]);
    NY:=word2int(memw[ad_gui:3]);
  end;

  procedure SetGuiStyle(st:byte);
  begin
    STYLE:=st;
  end;

  function get_Gindex(b_num,data_i:byte):word;
  begin
    {9*(b_num-1)+2*(data_i-1)+5}
    get_Gindex:=9*b_num+2*data_i-6;
  end;

  procedure set_Bval(b_num,data_i:byte;val:word;ad_gui:word);
  begin
     if(b_num>0)and(b_num<=get_but_num(ad_gui))then
     begin
       if(data_i>=1)and(data_i<=4)then
       memw[ad_gui:get_Gindex(b_num,data_i)]:=val;
       if(data_i=5)then
       mem[ad_gui:get_Gindex(b_num,data_i)]:=val;
     end;
  end;

  function get_Bval(b_num,data_i:byte;ad_gui:word):longint;
  begin
     if(data_i>=1)and(data_i<=4)then
     get_Bval:=memw[ad_gui:get_Gindex(b_num,data_i)]
     +word2int(memw[ad_gui:3-(data_i mod 2)*2]);
     if(data_i=5)then
     get_Bval:=mem[ad_gui:get_Gindex(b_num,data_i)];
  end;

  procedure set_but(b_num:integer;x1,y1,x2,y2:word;shape:byte;ad_gui:word);
  begin
    set_bval(b_num,X_ONE,x1,ad_gui);
    set_bval(b_num,Y_ONE,y1,ad_gui);
    set_bval(b_num,X_TWO,x2,ad_gui);
    set_bval(b_num,Y_TWO,y2,ad_gui);
    set_bval(b_num,C_SHAPE,shape,ad_gui);
  end;

  procedure get_but(b_num:integer;var x1,y1,x2,y2:integer;var shape:byte;ad_gui:word);
  begin
     x1:=get_bval(b_num,X_ONE,ad_gui);
     y1:=get_bval(b_num,Y_ONE,ad_gui);
     x2:=get_bval(b_num,X_TWO,ad_gui);
     y2:=get_bval(b_num,Y_TWO,ad_gui);
     shape:=get_bval(b_num,C_SHAPE,ad_gui);
  end;

  function set_stl(b_num,frames,f_cvec:integer;col,style:byte;ad_stl:word):boolean;
  begin
    if(b_num>0)and(b_num<=mem[ad_stl:0])then
    begin
      mem[ad_stl:b_num*4-3]:=frames;
      mem[ad_stl:b_num*4-2]:=sign2byte(f_cvec);
      mem[ad_stl:b_num*4-1]:=col;
      mem[ad_stl:b_num*4-0]:=style;
      set_stl:=false;
    end
    else set_stl:=true;
  end;

  function get_stl(b_num:integer;var frames,f_cvec:integer;var col,style:byte;ad_stl:word):boolean;
  begin
    if(b_num>0)and(b_num<=mem[ad_stl:0])then
    begin
      frames:=mem[ad_stl:b_num*4-3];
      f_cvec:=byte2sign(mem[ad_stl:b_num*4-2]);
      col:=mem[ad_stl:b_num*4-1];
      style:=mem[ad_stl:b_num*4];
      get_stl:=false;
    end
    else get_stl:=true;
  end;
  {*************************Control functions*************************}
  function on_the(xb,yb,x1,y1,x2,y2:integer;shape:byte):boolean;
  begin
    on_the:=false;
    if shape>0 then
    begin
      PPtoRad(x1,y1,x2,y2);
      if(x2<>0)and(y2<>0)then
        if(no_dis(shape,(x1-xb)/x2,(y1-yb)/y2)<1)then on_the:=true;
    end
    else
    begin
      flip_only(x1,x2);
      flip_only(y1,y2);
      if(xb>=x1)and(xb<=x2)and(yb>=y1)and(yb<=y2)then on_the:=true;
    end;
  end;

  function a_butten(num:byte;xm,ym:integer;ad_gui:word):boolean;
  begin
    if on_the(xm,ym,
      get_Bval(num,X_ONE,ad_gui),get_Bval(num,Y_ONE,ad_gui),
      get_Bval(num,X_TWO,ad_gui),get_Bval(num,Y_TWO,ad_gui),
      get_Bval(num,C_SHAPE,ad_gui))then
      a_butten:=true
    else
      a_butten:=false;
  end;

  function get_butten(xm,ym:integer;ad_gui:word):byte;
  var
    i:byte;
  begin
    get_butten:=0;
    for i:=mem[ad_gui:0] downto 1 do
    if a_butten(i,xm,ym,ad_gui) then
    begin
      get_butten:=i;
      Break;
    end;
  end;

  function get_buttens(xm,ym:integer;ad_gui:word):word;
  var
    i:byte;
    return:word;
  begin
    return:=0;
    for i:=0 to round(min(15,mem[ad_gui:0]-1)) do
    if a_butten(i+1,xm,ym,ad_gui)then
      return:=return+XnY(2,i);
    get_buttens:=return;
  end;

  {****************************Graphics functions************************}
  procedure GuiPixel(x,y:integer;col:byte;ad_vs:word);
  begin
    if X > 319 then exit;
    if Y > 199 then exit;
    if X < 0 then exit;
    if Y < 0 then exit;
    mem[ad_vs:y shl 8+y shl 6+x]:=col;
  end;

  procedure paint_a_but(num:byte;ad_gui:word;frames,f_cvec:integer;col:byte;ad_vs:word);
  begin
       ShapeWindow(get_Bval(num,X_ONE,ad_gui),get_Bval(num,Y_ONE,ad_gui),
                get_Bval(num,X_TWO,ad_gui),get_Bval(num,Y_TWO,ad_gui),
                get_Bval(num,C_SHAPE,ad_gui),frames,f_cvec,col,ad_vs);
  end;

  procedure paint_gui(ad_gui:word;frames,f_cvec:integer;col:byte;ad_vs:word);
  var
    i:integer;
  begin
    for i:=1 to mem[ad_gui:0] do
    ShapeWindow(get_Bval(i,X_ONE,ad_gui),get_Bval(i,Y_ONE,ad_gui),
                get_Bval(i,X_TWO,ad_gui),get_Bval(i,Y_TWO,ad_gui),
                get_Bval(i,C_SHAPE,ad_gui),frames,f_cvec,col,ad_vs);
  end;


  procedure paint_stl(name:string;ad_gui:word;ad_vs:word);
  var
    i:integer;
    data:file of byte;
    temp,oldstyle:byte;
    bnum,frames,col:byte;
    f_cvec:integer;
  begin
    oldstyle:=STYLE;
    Assign(data,name); {Opening the Font file}
    Reset(data);
    read(data,temp);
    bnum:=round(min(mem[ad_gui:0],temp));
    for i:=1 to bnum do
    begin
        read(data,frames);
        read(data,temp);
        f_cvec:=byte2sign(temp);
        read(data,col);
        read(data,STYLE);
        ShapeWindow(get_Bval(i,X_ONE,ad_gui),get_Bval(i,Y_ONE,ad_gui),
                get_Bval(i,X_TWO,ad_gui),get_Bval(i,Y_TWO,ad_gui),
                get_Bval(i,C_SHAPE,ad_gui),frames,f_cvec,col,ad_vs);
    end;
    close(data);
    STYLE:=oldstyle;
  end;

  procedure paint_stl_ad(ad_stl:word;ad_gui:word;ad_vs:word);
  var
    bnum:byte;
  begin
    bnum:=round(min(mem[ad_gui:0],mem[ad_stl:0]));
    P_stl(1,bnum,ad_stl,ad_gui,ad_vs);
  end;

  procedure P_stl(a,b:integer;ad_stl:word;ad_gui:word;ad_vs:word);
  var
    i:integer;
    data:file of byte;
    temp,oldstyle:byte;
    bnum,frames,col:byte;
    f_cvec:integer;
  begin
    oldstyle:=STYLE;
    bnum:=round(min(min(mem[ad_gui:0],mem[ad_stl:0]),b));
    if a<1 then a:=1;
    for i:=a to b do
    begin
        frames:=mem[ad_stl:i*4-3];
        f_cvec:=byte2sign(mem[ad_stl:i*4-2]);
        col:=mem[ad_stl:i*4-1];
        STYLE:=mem[ad_stl:i*4];

        ShapeWindow(get_Bval(i,X_ONE,ad_gui),get_Bval(i,Y_ONE,ad_gui),
                get_Bval(i,X_TWO,ad_gui),get_Bval(i,Y_TWO,ad_gui),
                get_Bval(i,C_SHAPE,ad_gui),frames,f_cvec,col,ad_vs);
    end;

    STYLE:=oldstyle;
  end;

{  function shader(x,y:real):real;
  begin
    shader:=no_deg(style,x,y);
  end;}

  Procedure putbar(x1,y1,x2,y2:integer;col:byte;ad_vs:word);
  var
    x,y:integer;
  begin
    for x:=x1 to x2 do
    for y:=y1 to y2 do
    GuiPixel(x,y,col,ad_vs);
  end;


  Procedure putSframe(x1,y1,x2,y2,i,frames,f_cvec:integer;col:byte;ad_vs:word);{?}
  var
    x,y:integer;
    col1,col2:byte;
    xc,yc,xrad,yrad:integer;
  begin
    col1:=col;
    col2:=col;
    case STYLE of
      1:begin
        col1:=col+(i-frames)*f_cvec;
        col2:=col+(i-frames)*f_cvec;
      end;
      2:begin
        col1:=col-(i-frames)*f_cvec;
        col2:=col+(i-frames)*f_cvec;
      end;
      else
      begin
        xc:=x1;yc:=y1;xrad:=x2;yrad:=y2;
        PPtoRad(xc,yc,xrad,yrad);
      end;
    end;
    for x:=x1 to x2 do
    begin
      if(STYLE>2)and(xrad<>0)and(yrad<>0)then
      begin
        col1:=col+round((i-frames)*f_cvec*no_deg(style,(x-xc)/xrad,-(y1-yc)/yrad));
        col2:=col+round((i-frames)*f_cvec*no_deg(style,(x-xc)/xrad,-(y2-yc)/yrad));
      end;
      guipixel(x,y1,col1,ad_vs);
      guipixel(x,y2,col2,ad_vs);
    end;
    for y:=y1 to y2 do
    begin
      if(STYLE>2)and(xrad<>0)and(yrad<>0)then
      begin
        col1:=col+round((i-frames)*f_cvec*no_deg(style,(x1-xc)/xrad,-(y-yc)/yrad));
        col2:=col+round((i-frames)*f_cvec*no_deg(style,(x2-xc)/xrad,-(y-yc)/yrad));
      end;
      guipixel(x1,y,col1,ad_vs);
      guipixel(x2,y,col2,ad_vs);
    end;
  end;

  function getCvecSign(butNum:byte;ad_stl:word):integer;
  begin
    getCvecSign:=sign(byte2sign(mem[ad_stl:(butNum-1)*4+2]));
  end;

  procedure GuiPressBut(butNum:byte;color:integer;ad_stl:word);
  begin
    setSTLColor(butnum,getStlColor(butnum,ad_stl)-
    sign(byte2sign(mem[ad_stl:(butNum-1)*4+2]))*color,ad_stl);
    FlipCvec(butNum,ad_stl);
  end;

  procedure FlipCvec(butNum:byte;ad_stl:word);
  begin
    if (ButNum-1)<=mem[ad_stl:0] then
      mem[ad_stl:(ButNum-1)*4+2]:=sign2byte(-1*byte2sign(mem[ad_stl:(butNum-1)*4+2]))
  end;

  procedure setStlColor(butNum,color:byte;ad_stl:word);
  begin
    if (ButNum-1)<=mem[ad_stl:0] then
      mem[ad_stl:(ButNum-1)*4+3]:=color;
  end;

  procedure GetButCent(num:byte;var x,y:integer;ad_gui:word);
  begin
    x:=getButXc(num,ad_gui);
    y:=getButYc(num,ad_gui);
  end;

  function getButXc(num:byte;ad_gui:word):integer;
  begin
    getButXc:=(get_Bval(num,X_ONE,ad_gui)+get_Bval(num,X_TWO,ad_gui)) div 2;
  end;

  function getButYc(num:byte;ad_gui:word):integer;
  begin
    getButYc:=(get_Bval(num,Y_ONE,ad_gui)+get_Bval(num,Y_TWO,ad_gui)) div 2;
  end;

  function getStlColor(butNum:byte;ad_stl:word):byte;
  begin
    if (ButNum-1)<=mem[ad_stl:0] then
      getStlColor:=mem[ad_stl:(ButNum-1)*4+3]
    else
      getStlColor:=0;
  end;

  Procedure recSwindow(x1,y1,x2,y2,frames,f_cvec:integer;col:byte;ad_vs:word);
  var
    i:integer;
  begin
    flip_only(x1,x2);
    flip_only(y1,y2);
    putbar(x1+frames,y1+frames,x2-frames,y2-frames,col,ad_vs);
    for i:=frames-1 downto 0 do
    putSframe(x1+i,y1+i,x2-i,y2-i,i,frames,f_cvec,col,ad_vs);
  end;

  procedure ShapeWindow(x1,y1,x2,y2,shape,frames,f_cvec:integer;col:byte;ad_vs:word);
  var
    x,y:integer;
    xc,yc,xrad,yrad:integer;
    shade:real;
    col_f:byte;
    dis:real;
  begin
    flip_only(x1,x2);
    flip_only(y1,y2);
    if shape>0 then
    begin
      xc:=x1;yc:=y1;xrad:=x2;yrad:=y2;
      PPtoRad(xc,yc,xrad,yrad);
      if(xrad<>0)and(yrad<>0)then
      for x:=x1 to x2 do for y:=y1 to y2 do
      if on_the(x,y,x1,y1,x2,y2,shape)then
      begin
        dis:=no_dis(shape,(xc-x)/xrad,(yc-y)/yrad);
        if dis>1-frames/max(xrad,yrad) then
        begin
          shade:=no_deg(style,(x-xc)/xrad,-(y-yc)/yrad);
          col_f:=round((dis*max(xrad,yrad)-max(xrad,yrad)+frames)*shade*f_cvec);
        end else col_f:=0;
        guipixel(x,y,col-col_f,ad_vs);
      end;
  end
      else
      recSwindow(x1,y1,x2,y2,frames,f_cvec,col,ad_vs);
  end;




 begin
   STYLE:=3;
 end.
