{Mcga_pal - a palette FX & control Unit Virtion 1.00 by Kobi Nistel}
unit mcga_pal;
interface
  Const Pal=0;

  {1.allocates memory for virtual palette}
  function get_vpal(var vp:pointer):word;
  {2.frees memory of virtual palette}
  procedure free_vpal(vp:pointer);
  {3.gets palette from memory or from real palette if ad=0}
  procedure Get_pal(Col:Byte; Var R,G,B: Byte;adp:word);
  {4.sets palette to memorey or real palette if ad=0}
  procedure Set_pal(Col:Byte; R,G,B:Byte;adp:word);
  {5.grabs the palette to the virtual pal}
  Procedure Grab_pal(st,fin:byte;adp:word);
  {6.restores the palette form virtual palette}
  Procedure Restore_Pal(st,fin:byte;adp:word);
  {7.sets fire like palette}
  procedure Set_Fire(from,f,c:byte;adp:word);
  {8.copy palette from palette source to the destanayion}
  Procedure move_pal(st,fin,source,destination:Word);
  {9.moves the palette value colser by one to the virtual palette}
  Procedure fade_to_loop(st,fin:byte;adp:word);
  {10.fades the palette in to the virtual palette}
  Procedure Fade_To(st,fin:byte;Del:Integer;adp:word);
  {11.makes a palette mathmaticly}
  procedure math_pal(st,fin:byte;rp,gp,bp,rf,gf,bf:real;adp:word);
  Procedure fade_to_math(st,fin:byte;rp,gp,bp,rf,gf,bf:real);

  {13.smothen the palette}
  procedure sm_pal(st,fin,rep:byte;adp_s,adp_ds:word);
  {14.shift palette}
  procedure shift_pal(st,fin:byte;vec:integer;adp:word);
  {15.chinges betwean the RGB values);}
  procedure swap_rgb(st,fin,num:byte;adp:word);
  {.opens palette from a file_name}
  procedure open_pal(file_name:string;adp:word);
  {.saves palette to file_name}
  procedure save_pal(file_name:string;adp:word);

implementation
  uses crt;

  function sign(num:real):integer; {in use of fadeTo}
  begin
    if num>0 then sign:=1
     else if num<0 then sign:=-1
      else sign:=0;
  end;

  function LinSin(x:real):real; {in use of math_pal}
     function ArcSin(x:real):real;
     begin
       ArcSin:= ArcTan (x/sqrt (1-sqr (x)));
     end;
  begin
    LinSin:=2/pi*arcsin(sin(x*pi/2));
  end;

  function get_rgb(col,num:byte;adp:word):byte;
  begin
    get_rgb:=mem[adp:col*3+num];
  end;

  function get_vpal(var vp:pointer):word;
  begin
    GetMem (Vp,768);
    get_vpal := seg(vp^);
  end;

  procedure free_vpal(vp:pointer);
  begin
    FreeMem(Vp, 768);
  end;

  procedure Get_pal(Col:Byte; Var R,G,B: Byte;adp:word);
  Begin;
    if adp=0 then
    begin
      Port[$3c7]:=Col;
      R:=Port[$3c9];
      G:=Port[$3c9];
      B:=Port[$3c9];
    end
    else
    begin
      r:=mem[adp:col*3];
      g:=mem[adp:col*3+1];
      b:=mem[adp:col*3+2];
    end;
  End;

  procedure Set_pal(Col:Byte; R,G,B:Byte;adp:word);
  Begin
    if adp=0 then
    begin
      Port[$3c8]:=Col;
      Port[$3c9]:=R;
      Port[$3c9]:=G;
      Port[$3c9]:=B;
    end
    else
    begin
      mem[adp:col*3]:=r;
      mem[adp:col*3+1]:=g;
      mem[adp:col*3+2]:=b;
    end;
  End;

  Procedure Grab_pal(st,fin:byte;adp:word);
   Var
    I:Integer;
    r,g,b:byte;
  Begin
    For I:=st to fin do
    begin
      get_pal(i,r,g,b,pal);
      set_pal(i,r,g,b,adp);
    end;
  End;

  Procedure Restore_Pal(st,fin:byte;adp:word);
   Var i:integer;
  Begin
  {  WaitRetrace;}
    For i:=st to fin do
     Set_Pal (i,get_rgb(i,0,adp),get_rgb(i,1,adp),get_rgb(i,2,adp),pal);
  End;

  procedure Set_Fire(from,f,c:byte;adp:word);
   var
    s:array[0..2]of byte;
    x,y:integer;
  begin
     for x:=0 to 2 do s[x]:=0;
     for x:=0 to 2 do
     for y:=0 to 62 do
     begin
        s[x]:=s[x]+1;
        set_pal(from+y div f+x*(63 div f),s[c mod 3],s[(c+1+(c div 3))mod 3],s[(c+2-(c div 3))mod 3],adp);
     end;
  end;

  Procedure move_pal(st,fin:word;source,destination:Word);
  Var
    i:integer;
    r,g,b:byte;
  Begin
    For i:=st to fin do
    begin
      Get_pal(i,r,g,b,source);
      Set_Pal(i,r,g,b,destination);
    end;
  End;

  Procedure fade_to_loop(st,fin:byte;adp:word);
  Var
    I,C,rgb:Integer;
    rp,vp:array[1..3]of byte;
  Begin
      For C:=st to fin do
      begin
        get_pal(c,rp[1],rp[2],rp[3],pal);
        get_pal(c,vp[1],vp[2],vp[3],adp);
        for rgb:=1 to 3 do
          rp[rgb]:=rp[rgb]+sign(vp[rgb]-rp[rgb]);
        set_pal(c,rp[1],rp[2],rp[3],pal);
      end;
  end;

  procedure fade_to(st,fin:byte;del:integer;adp:word);
  var
    i:integer;
  begin
    for i:=1 to 64 do
    begin
      fade_to_loop(st,fin,adp);
      delay(del);
    end;
  end;

{  procedure math_pal(st,fin:byte;rp,gp,bp,rf,gf,bf:real;adp:word);
    var
      i:integer;
  begin
    for i:=st to fin do
      set_pal(i,
      round(LinSin(rp+(i-st)/rf-1)*31.5)+32,
      round(LinSin(gp+(i-st)/gf-1)*31.5)+32,
      round(LinSin(bp+(i-st)/bf-1)*31.5)+32,adp);
  end;}

    procedure math_pal(st,fin:byte;rp,gp,bp,rf,gf,bf:real;adp:word);
    var
      i:integer;
  begin
    for i:=st to fin do
      set_pal(i,
      round(LinSin(rp/31.5+(i-st)/rf-1)*31.5)+32,
      round(LinSin(gp/31.5+(i-st)/gf-1)*31.5)+32,
      round(LinSin(bp/31.5+(i-st)/bf-1)*31.5)+32,adp);
  end;

  Procedure fade_to_math(st,fin:byte;rp,gp,bp,rf,gf,bf:real);
  Var
    I,C,rgb:Integer;
    grp,vp:array[1..3]of byte;
  Begin
      For C:=st to fin do
      begin
        get_pal(c,grp[1],grp[2],grp[3],pal);
        vp[1]:=round(LinSin(rp/31.5+(c-st)/rf-1)*31.5)+32;
        vp[2]:=round(LinSin(gp/31.5+(c-st)/gf-1)*31.5)+32;
        vp[3]:=round(LinSin(bp/31.5+(c-st)/bf-1)*31.5)+32;
        for rgb:=1 to 3 do
          grp[rgb]:=grp[rgb]+sign(vp[rgb]-grp[rgb]);
        set_pal(c,grp[1],grp[2],grp[3],pal);
      end;
  end;

  procedure sm_pal(st,fin,rep:byte;adp_s,adp_ds:word);
  var
   i,repi,r1,g1,b1,r2,b2,g2:byte;
  begin
    for repi:=1 to rep do
    for i:=st to fin do
    begin
      if i > st then get_pal(i-1,r1,g1,b1,adp_s)
      else get_pal(fin,r2,g2,b2,adp_s);

      if i < fin then get_pal(i+1,r2,g2,b2,adp_s)
      else get_pal(st,r2,g2,b2,adp_s);
      set_pal(i,(r1+r2)div 2,(g1+g2)div 2,(b1+b2)div 2,adp_ds);
    end;
  end;

  procedure shift_pal(st,fin:byte;vec:integer;adp:word);
  var
    r,g,b,r2,g2,b2:byte;
    i:integer;
  begin
    if vec>0 then
    begin
      get_pal(st,r2,g2,b2,adp);
      for i:=st to fin-1 do
      begin
        get_pal(i+1,r,g,b,adp);
        set_pal(i,r,g,b,adp);
      end;
      set_pal(fin,r2,g2,b2,adp);
    end;
    if vec<0 then
    begin
      get_pal(fin,r2,g2,b2,adp);
      for i:=fin downto st+1 do
      begin
        get_pal(i-1,r,g,b,adp);
        set_pal(i,r,g,b,adp);
      end;
      set_pal(st,r2,g2,b2,adp);
    end;
  end;


  procedure swap_rgb(st,fin,num:byte;adp:word);
   var
    i:integer;
    r,g,b:byte;
  begin
    for i:=st to fin do
    begin
      get_pal(i,r,g,b,adp);
      case num of
        0:set_pal(i,0,0,0,adp); {black out}
        1:set_pal(i,63-r,63-g,63-b,adp); {inverce}
        2:set_pal(i,63-r,g,b,adp);
        3:set_pal(i,r,63-g,b,adp);
        4:set_pal(i,r,g,63-b,adp);
        5:set_pal(i,r,b,g,adp);
        6:set_pal(i,b,r,g,adp);
        7:set_pal(i,b,g,r,adp);
        8:set_pal(i,g,r,b,adp);
        9:set_pal(i,g,b,r,adp);
        10:set_pal(i,(r+g+b)div 3,(r+g+b)div 3,(r+g+b)div 3,adp);
        11:set_pal(i,r,g,0,adp);
        12:set_pal(i,r,0,b,adp);
        13:set_pal(i,0,g,b,adp);
        14:set_pal(i,r,r,r,adp);
        15:set_pal(i,g,g,g,adp);
        16:set_pal(i,b,b,b,adp);
      end;
    end;
  end;

  procedure open_pal(file_name:string;adp:word);{to add an addres to load the palette}
  var
    w:word;
    sb:file of byte;
    r,g,b:byte;
  begin
    Assign(sb,file_name);
    Reset(sb);
    for w:=0 to 255 do
    begin
      read(sb,r);
      read(sb,g);
      read(sb,b);
      set_pal(w,r,g,b,adp);
    end;
    Close(sb);
  end;

  procedure save_pal(file_name:string;adp:word);
  var
    w:word;
    sb:file of byte;
    r,g,b:byte;
  begin
    Assign(sb,file_name);
    Rewrite(sb);
    for w:=0 to 255 do
    begin
      get_pal(w,r,g,b,adp);
      write(sb,r);
      write(sb,g);
      write(sb,b);
    end;
    Close(sb);
  end;

begin
end.