{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}

Unit mouse_u; { Tim Gordon's Mouse unit (01/08/97) }

interface
uses dos;
 Const
  m_dispaly:array[-3..3,-3..3]of byte=(
  (0,0,0,1,0,0,0),
  (0,0,0,1,0,0,0),
  (0,0,0,0,0,0,0),
  (1,1,0,0,0,1,1),
  (0,0,0,0,0,0,0),
  (0,0,0,1,0,0,0),
  (0,0,0,1,0,0,0));
type
 RmouseData = record
   px,py,lx,ly,x,y:word; {mouse varibels}
   lb,b:byte;      {mouse varibels}
   clickL,clickR:boolean;{mouse varibels}
 end;

 Omouse = object
     m_dispaly1:array[-3..3,-3..3]of byte;
     px,py,lx,ly,x,y:word; {mouse varibels}
     lb,b:byte;      {mouse varibels}
     click1,click2:boolean;{mouse varibels}
     constructor NewMouse;
     destructor KillMouse;
     procedure refresh;
     procedure display(c:byte;ad:word);
     procedure Del(ad:word);
     function  getX:integer;
     function  getY:integer;
     function  getLastX:word;
     function  getLastY:word;
     function  getPressdX:word;
     function  getPressdY:word;
     function  ClickL:boolean;
     function  ClickR:boolean;
     function  ClickLR:boolean;
     function  GetB:byte;
     function  GetLB:byte;
     procedure GetMouseData(var MD:RmouseData);
 end;

var
   minit       : boolean;
   buttons     : word;
   leftrelease : boolean;
   regs        : registers;
   mode:byte;

procedure set_cur(b,color,inMode:byte);
Procedure ResetMouse; { Initialize mouse }
Function getmousex : word; { Get mouse position on X axis }
Function getmousey : word; { Get mouse position on Y axis }
Function leftpressed : Boolean; { Check if left button is pressed }
Function rightpressed : Boolean; { "    "  right "     "    "     }
Function MouseInstalled : Boolean; { Check if mouse is present }
Procedure SetMouseWindow (X1,Y1,X2,Y2:integer); { Set mouse restrictions }
procedure getmouse(var x,y:word;var b:byte);
procedure smartmouse(var x,y,lx,ly:word;var b:byte;var click1,click2:boolean);

implementation
uses math_unt;

Procedure pixel(sel:byte;X,Y: Integer; Color: Byte;ad:word);
begin
  if(x>=0)and(x<320)and(y>=0)and(y<200)and(ad<>0)then
  case sel of
   0:mem[ad:y shl 8+y shl 6+x]:=color;
   1:mem[ad:y shl 8+y shl 6+x]:=mem[ad:y shl 8+y shl 6+x]+color;
  end;
End;

Function Getpixel(x,y : integer;ad:word):byte;
begin
 if(x>=0)and(x<320)and(y>=0)and(y<200)then
 GetPixel:=mem[ad:y shl 8+y shl 6+x];
end;

  constructor Omouse.NewMouse;
  begin
     X:=160;
     Y:=100;
     lx:=x;
     ly:=y;
     Px:=x;
     Py:=y;
     Click1:=false;
     Click2:=false;
     lb:=0;
     b:=0;
  end;
  destructor Omouse.KillMouse;
  begin
  end;

  procedure Omouse.refresh;
  begin
    lx:=x;
    ly:=y;
    lb:=b;
    smartmouse(x,y,px,py,b,click1,click2);
  end;

  procedure Omouse.Display(c:byte;ad:word);
  var
    xx,yy:integer;
  begin
    for xx:=-3 to 3 do for yy:=-3 to 3 do
    if M_dispaly[xx,yy]<>0 then
    begin
      M_dispaly1[xx,yy]:=getpixel(xx+x,yy+y,ad);;
      pixel(Mode,xx+x,yy+y,c+M_dispaly[xx,yy]-1,ad);
    end;
  end;

  procedure Omouse.Del(ad:word);
  var
    xx,yy:integer;
  begin
    for xx:=-3 to 3 do for yy:=-3 to 3 do
    if M_dispaly[xx,yy]<>0 then pixel(0,xx+x,yy+y,M_dispaly1[xx,yy],ad);
  end;

  function  Omouse.getX:integer;
  begin
    getX:=x;
  end;

  function  Omouse.getY:integer;
  begin
    getY:=y;
  end;

  function  Omouse.getLastX:word;
  begin
    getLastX:=lx;
  end;

  function  Omouse.getLastY:word;
  begin
    getLastY:=ly;
  end;

  function  Omouse.getPressdX:word;
  begin
    getPressdX:=px;
  end;

  function  Omouse.getPressdY:word;
  begin
    getPressdY:=py;
  end;

  function  Omouse.ClickL:boolean;
  begin
    ClickL:=Click1;
  end;

  function  Omouse.ClickR:boolean;
  begin
    ClickR:=Click2;
  end;

  function  Omouse.ClickLR:boolean;
  begin
    if(lb>0)and(b=0) then
      ClickLR:=true
    else
      ClickLR:=false;
  end;

  function  Omouse.GetB:byte;
  begin
    GetB:=b;
  end;

  function  Omouse.GetLB:byte;
  begin
    getLb:=lb;
  end;

  procedure Omouse.GetMouseData(var MD:RmouseData);
  begin
     MD.px:=px;
     MD.py:=py;
     MD.lx:=lx;
     MD.ly:=ly;
     MD.x:=x;
     MD.y:=y;
     MD.lb:=lb;
     MD.b:=b;
     MD.clickL:=click1;
     MD.clickR:=click2;
  end;

procedure set_cur(b,color,inMode:byte);
var
  x,y:integer;
begin
  Mode:=inMode;
  for x:=-3 to 3 do for y:=-3 to 3 do
  m_dispaly[x,y]:=0;
  if b=0 then
    for x:=2 to 3 do
    begin
      m_dispaly[0,x]:=color;
      m_dispaly[x,0]:=color;
      m_dispaly[0,-x]:=color;
      m_dispaly[-x,0]:=color;
    end
  else
  for x:=-3 to 3 do for y:=-3 to 3 do
  case b of
    1:if round(sqrt(x*x+y*y))<4 then m_dispaly[x,y]:=color+4-round(sqrt(x*x+y*y));
    else if(no_dis(b,x/3,y/3)<1)then m_dispaly[x,y]:=round(4-no_dis(b,x/3,y/3)*5)+color;
  end;
end;

Procedure SetMouseWindow (X1,Y1,X2,Y2:integer);
Begin
     asm
       mov ax,$0007 { Set mouse x limits }
       mov cx,x1
       mov dx,x2
       int 33h { Execute mouse interrupt }
       mov ax,$0008 { Set mouse y limits }
       mov cx,y1
       mov dx,y2
       int 33h { Execute mouse interrupt }
     end;
End;

Function  MouseInstalled : Boolean;
Begin
     With Regs do
     Begin
          AX := $0000;
          Intr($33,Regs);
          MouseInstalled := not AX = 0;
     End;
     { I could convert this routine to assembler, but I can't figure out
       what to do with "mouseinstalled := not ax = 0" }
End;

Procedure ResetMouse; Assembler;
ASM { This routine is NOT written by me :) }
  xor AX, AX
  Int 33h { Mouse interrupt }
  cmp AX, - 1
  jne @skip
  mov minit, True
  mov buttons, BX
  mov LeftRelease, False
  @skip:
END;

FUNCTION getmousex : word; Assembler;
ASM
  mov AX, 3
  Int 33h { Mouse interrupt }
  mov AX, CX
END;

FUNCTION getmousey : word; Assembler;
ASM
  mov AX, 3
  Int 33h { Mouse interrupt }
  mov AX, DX
END;

FUNCTION leftpressed : Boolean; Assembler;
ASM
  mov AX, 3
  Int 33h { Mouse interrupt }
  And BX, 1
  mov AX, BX
END;

FUNCTION rightpressed : Boolean; Assembler;
ASM
  mov AX, 3
  Int 33h { Mouse interrupt }
  And BX, 2
  mov AX, BX
END;

procedure getmouse(var x,y:word;var b:byte);
begin
  x:=getmousex;
  y:=getmousey;
  if leftpressed then b:=1 else b:=0;
  if rightpressed then b:=b+2;
  x:=x div 2;
end;

procedure smartmouse(var x,y,lx,ly:word;var b:byte;var click1,click2:boolean);
var
 lb:byte;
begin
  if(b=1)and(not(leftpressed))then click1:=true else click1:=false;
  if(b=2)and(not(rightpressed))then click2:=true else click2:=false;
  lb:=b;
  getmouse(x,y,b);
  if(lb=0)then
  begin
    lx:=x;
    ly:=y;
  end;
end;


begin
  mode:=0;
end.